/* Created by EasyMotif EasyMotif Release:2_3_8_6  */

/*
 *    Project:    Function        Path:    ./
 *    Program-name:    Hex
 *    Designer:    J.Keidel        Version:    $Revision: 1.7 $
 *    Description:    Assembling Functions
*/
#include  <stdio.h>
#include  <stdlib.h>
/*     Includes */

#include <Xm/XmAll.h>
#include <XMind.h>
#include <math.h>
#include  "Hex.h"
/*   PRIVATE INCLUDES   */
/* Global Header */
#include "Hex.h"


/*   PRIVATE DEFINES   */


/*** PRIVATE HEADER DECLARATIONS ***/ 
		/* static variable to check and assermble for modification */
static char 		pair[20];
/* static XmTextPosition 	start,end; */
XmTextPosition 	TXstart=0;
XmTextPosition 	TXend=0;
XmTextPosition 	TXnpos=0;
XmTextPosition 	TXpos=0;
int             TXaddr;
XmTextPosition 	TNnpos=0;
/* XmTextPosition 	TNpos=0; */
XmTextPosition   TNstart=0, TNend=0;
int              TNaddr;
static unsigned char 	pattern[4];
static unsigned char 	smask[4];
static int           	Saddr = 0;
static int              Ssize = 0;
static int              Bpos = 0;
static unsigned char    Inp[5];        /* used fopr bitaligned search only */

int                     Maddr=0;
int                     SearchTyp = BYTE_ALIGN;
 
/*** PRIVATE PROTOTYPES  ***/ 


/***  END of HEADER  ***/


/*     GLOBAL WIDGETS */


/*     GLOBAL Graphics */


/*    STATIC GLOBAL WIDGETS */


/*    STATIC GLOBAL Graphics */


/*    Prototypes */


/*    FUNCTIONS */

static int do_search ( void ) ;
static int maskit ( unsigned char *patt ) ;
static int check_bitalign (int *bit ) ;



/*    FUNCTIONS */

/***************************************************************************
 ***************************************************************************

  Functionname:		Reset_mod
  
  Input:		
  Output:   	    	
  
  Return:		void

  Documentation:	resets the static position variables to zero
                        clears any selection


  History:		Tue Dec 16 12:30:07 2008



 ***************************************************************************
 ***************************************************************************/
void Reset_mod ( void ) {
	
        TNstart = TNend = TXstart = TXend= 0 ;
        TNnpos=Maddr=0; 

        XmTextClearSelection(Hex_Text,  XtLastTimestampProcessed(XtDisplay(Hex_Number)));
        XmTextClearSelection(Hex_Number,  XtLastTimestampProcessed(XtDisplay(Hex_Number)));
}

/***************************************************************************
 ***************************************************************************

  Functionname:		selected
  
  Input:		
  Output:   	    	
  
  Return:		Bool

  Documentation:	if no selection range, does nothing
                        moves the selection to next hex-digit
                        in case of editable, checks the selection range 
                        for non hex-digits, raises error message if so.
                        finally, converts the selected position to position
                        in the buffers and in the mapping.
                        put the selected (word) into the control-field and into the
                        input-field for editing. 
                        puts the corresponding area of the other displaed field
                        to the corresponding input field.
                        that mean, that selecting a Hex-Number the correspondig 
                        text-string will appear in the text input-field, the hex 
                        value will go th th Hex-input field.
                        this will work as well from the text-field as from the Hex-field.
                        in both cases a full 32.bit-word is selected and transferred.

  History:		Tue Dec 16 12:23:55 2008
                        Mai 24 07:09:13 CEST 2016


 ***************************************************************************
 ***************************************************************************/
Bool selected ( int which) {
  int i,j;
  char str[9];
  static unsigned char D[16]="0123456789ABCDEF";
  unsigned char strg[5];
  
	MTextSetString (Hex_error, "");   /* clear error message first*/
        if(which == 1){
	    XmTextGetSelectionPosition(Hex_Number,&TNstart,&TNend);
            if(TNstart == TNend || !TNend)
        	return  FALSE;
                
            TXstart=(TXstart/5)*5;    
            if(!isxdigit(Hex_number[TNstart] )){
        	TNstart++ , TNend++;
                if(!isxdigit(Hex_number[TNstart] /* || iscntrl(Hex_number[TNstart]) */ )) 
                    TNstart++,TNend++;
          	XmTextSetSelection(Hex_Number, TNstart, TNend,
       		    XtLastTimestampProcessed(XtDisplay(Hex_Number)));  
                XmTextSetHighlight(Hex_Number, TNstart, TNend,XmHIGHLIGHT_SELECTED);
                XFlush(XtDisplay(Hex_Number));    
            }

            for (i=TNstart;i<TNend;i++){
        	if(!isxdigit(Hex_number[i]) && EDITABLE){
                    MTextSetString (Hex_error, "bad selection, truncated to first word");
                    break;
                }
            }
            
            MTextSetString (Hex_input,Hex_number);
	    TNaddr = Startaddress + ((TNstart / 72) *8 + ((TNstart % 72)/9)) *4;
            
	    Maddr = (TNaddr/4)*4;
        
        }else if(which ==2){
	    XmTextGetSelectionPosition(Hex_Text,&TXstart,&TXend);
            if(TXstart == TXend || !TXend)
        	return  FALSE;
            TXstart = (TXstart/5)*5 ;
                 
            XmTextSetSelection(Hex_Text, TXstart, TXend,
       			XtLastTimestampProcessed(XtDisplay(Hex_Text)));  
            XmTextSetHighlight(Hex_Text, TXstart, TXend,XmHIGHLIGHT_SELECTED);
            XFlush(XtDisplay(Hex_Text));    
            
            for (i=TXstart;i<TXend;i++){
        	if(!isalnum(Hex_text[i]) && EDITABLE){
                    MTextSetString (Hex_error, "bad selection, truncated to first word");
                    break;
                }
            }
            XmTextSetHighlight(Hex_Text, TXstart, TXend,XmHIGHLIGHT_SELECTED);
            XFlush(XtDisplay(Hex_Text));    
    
	    TXaddr = Startaddress + ((TXstart / 5) *4 )/* + ((TXstart % 32)/5)) *4 */;
	    Maddr = (TXaddr/4)*4;
        }

        if(which == 1){       
            TNnpos = ((TNstart / 72) *72 + ((TNstart % 72)/9)*9);
            
   
       }
    
       for (i=0,j=0;i<4;i++){
            if(isprint(Map[Maddr+i]) /* && ! iscntrl(Map[Maddr+i]) */)
 	        strg[j++]=Map[Maddr+i];
	    else
	        strg[j++]= '.';
       }        
  	strg[j]=0;
      MTextSetString (Hex_TE_input,strg);
      
      
        /* display the Control and input fields from the mapped fil */ 
 	for (i=0,j=0;i<4;i++){
	    str[j++]=D[Map[Maddr+i]>>4];
	    str[j++]=D[Map[Maddr+i] & 0x0f];
	}        
	str[j]=0;
        MTextSetHex(Hex_Maddress,Maddr );
	MTextSetString (Hex_control, str); 
	MTextSetString (Hex_input, str);
        if(which == 1){
	    XtSetKeyboardFocus(Hex, Hex_input);      
	}else if (which == 2){
            XtSetKeyboardFocus(Hex, Hex_TE_input);
        }
        return TRUE;      
}



/***************************************************************************
 ***************************************************************************

  Functionname:		rewrite
  
  Input:		char *text
  Output:   	    	
  
  Return:		void

  Documentation:	the given Text is assumed to only hex digits max 8 chars long
                        it will be reconverted to 4 binary bytes, and to 4
                        printable characters.
                        It will be written in the Hexnumber Text, the text and
                        written back to the mapped file.
                        The stored buffers are updated as well


  History:		Thu Dec 11 17:09:16 2008



 ***************************************************************************
 ***************************************************************************/
void rewrite ( char *text ) {
   int i , n;
   unsigned char replace[5] , rtext[5];
   
   	memset(replace,0,sizeof(replace));
   	memset(rtext,0,sizeof(rtext));
        n = strlen(text);
   	reconvert  (text,replace,n);	/* get the binary representation */
        for(i=0;i<n/2;i++){		/* construct the printable representation */
		if(isprint(replace[i]) /*&&  ! iscntrl(replace[i]) */)                
		    rtext[i]=replace[i];
                else if (iscntrl(replace[i]))
                    rtext[i]='.' ;      
		else
		    rtext[i]='.';
        
	}
	XmTextReplace(Hex_Text, TXpos,TXpos+n/2,(char *)rtext); /* update the Text widget */
	memcpy(&Hex_text[TXpos],rtext,n/2);		/* and the buffer */
        if(EDITABLE)
        	memcpy(&Map[Maddr],replace,n/2);     /* modify the file */
        XmTextReplace(Hex_Number,TNnpos,TNnpos+n,text);/* update the Hex-number widget */
        memcpy(&Hex_number[TNnpos],text,n);	   /* and the buffer */
        Display_it();
}

/***************************************************************************
 ***************************************************************************

  Functionname:		reconvert
  
  Input:		char *text     8 characters of Hexnumber
                        
  Output:   	    	unsigned char *hex
  
  Return:		 void

  Documentation:	converts the input into 4*8 bit unsigned char *hex
                        The conversion is done manually, as scanf refuses to do it?!
                        

  History:		Thu Dec 11 14:20:53 2008



 ***************************************************************************
 ***************************************************************************/
void reconvert ( char *text , unsigned char *hex , int ndigits) {
   int  i ,j ,k;

   static char   D[22]="0123456789ABCDEFabcdef";
   static unsigned char H[22]={0,1,2,3,4,5,6,7,8,9,0xa,0xb,0xc,0xd,0xe,0xf,0xa,0xb,0xc,0xd,0xe,0xf};

	memset(hex,0,ndigits/2);
        
        for(i=0,j=0;i<ndigits;i++){
		for(k=0;k<22;k++){
             		if(D[k] == text[i]){
                     		hex[j] |= (!(i&1))?H[k]<<4 : H[k];
                                break;
                     	}
   		}         
 		if (i&1) 
                	j++;
	}


}

/***************************************************************************
 ***************************************************************************

  Functionname:		display_address
  
  Input:		unsigned int addr , int flag
  Output:   	    	
  
  Return:		void

  Documentation:	positions the display and select the given address
                        redisplay if necessary
			selection is done IF flag == 0, on word boundary
                        else on exact address

  History:		Sun Dec 14 10:17:25 2008



 ***************************************************************************
 ***************************************************************************/
void display_address ( unsigned int addr , int flag) {
   int add = Startaddress;
   int i;
   
	Startaddress = (addr / Block_Size ) * Block_Size ;
        Endaddress    = Startaddress + Block_Size;
        if(add != Startaddress)
		Display_it ( );
                
	TNstart = ((addr-Startaddress)/32)*72 + (((addr-Startaddress)%32)/4)*9 ; 
        if(!flag)     
        	TNend   = TNstart + 8;
        else{
        	TNstart += (((addr-Startaddress)%32)%4)*2 ;
                TNend   =  TNstart + Ssize*2;  
                if((SearchTyp & BIT_ALIGN) == BIT_ALIGN)
                	TNend +=2;     /* compensate unaligned bitstring */
                for (i=TNstart;i< TNend;i++){
                	if( !isxdigit( Hex_number[i])) {
                        	TNend++;
                        	break;
                        }
                }  
        }
        XmTextSetSelection(Hex_Number,  TNstart, TNend, 
        		XtLastTimestampProcessed(XtDisplay(Hex_Number)));
        selected (1);
                       
}

/***************************************************************************
 ***************************************************************************

  Functionname:		search_pattern
  
  Input:		unsigned char *patt , unsigned char *mask ,int cont
  Output:   	    	
  
  Return:		void

  Documentation:	if cont == 0, sets internals to the given values, as well
                        as start address to 0 and masks the pattern already
			anyway calls do_search
                        
  History:		Wed Dec 17 14:41:43 2008



 ***************************************************************************
 ***************************************************************************/
int search_pattern ( unsigned char *patt , unsigned char *mask , int size ,int cont) {

	if(!cont){
		Saddr = 0;
                Bpos  = 0;
		memcpy(pattern,patt,4);
		memcpy(smask,mask,4);
		maskit(pattern);
		Ssize = size;
                memcpy(Inp,&Map[Saddr],Ssize);
                
	}else
		Saddr += Ssize;
	return do_search();        
}

/***************************************************************************
 ***************************************************************************

  Functionname:		do_search
  
  Input:		
  Output:   	    	
  
  Return:		 int    == 0 if pattern found

  Documentation:	Assuming the searched pattern is already masked,
                        and the mask will cover 4 bytes, compare 4 bytes, masking them
                        loops thu the mapped file and stops if 4 hits in a loop
                        
                        The comparision is done manually, as we can easier mask
                        and don't need to copy alsways. So its faster.
                        We should not forget, that there are plans to search bitwise for Hit,
                        which must be done manually.

  History:		Wed Dec 17 15:30:27 2008



 ***************************************************************************
 ***************************************************************************/
static int do_search ( void ) {
  int i;
  int found=1 ;
  
	do {
 		found = Ssize;
                if((SearchTyp & BIT_ALIGN) == BIT_ALIGN)
                	found = check_bitalign(&Bpos);
                else{
                
 			for (i=0;i<Ssize;i++){

                		if(pattern[i] == (Map[Saddr+i] & smask[i]))
                 	       		found--;
                        	else if(SearchTyp & INVERTED ){
                        		if(pattern[i] == (~(Map[Saddr+i]) & smask[i]))
                                		found--; 
                     	}   	} 
                }
                if(!found)
                	break;
                if(((SearchTyp &BYTE_ALIGN) == BYTE_ALIGN)
                    || ((SearchTyp & BIT_ALIGN) == BIT_ALIGN))        
			Saddr++;
                else if((SearchTyp & WORD_ALIGN) == WORD_ALIGN)
                	Saddr +=4;        
        }while (Saddr  <=  (Map_Size-Ssize));
                
        if(found)
        	return found;
        display_address (Saddr , 1); 
        if(Log){
        	fprintf(Log,"FOUND ADDR: %8x Word %2X"
                       , Saddr , Map[Saddr]); 
                for (i= 1;i< Ssize ; i++)
                	fprintf(Log,"%2X", Map[Saddr+i] );
                fprintf(Log,"\n");
        }        
        return 0;                       		
}

/***************************************************************************
 ***************************************************************************

  Functionname:		maskit
  
  Input:		unsigned char *patt
  Output:   	    	unsigned char *patt
  
  Return:		 void

  Documentation:	just mask the given pattern with the stored search-mask
                        to avoid superflouus masking during search


  History:		Thu Dec 18 09:49:35 2008



 ***************************************************************************
 ***************************************************************************/
static int maskit ( unsigned char *patt ) {
  int i;
	for(i=0;i<4;i++)
		patt[i] &= smask[i];

}

/***************************************************************************
 ***************************************************************************

  Functionname:     check_bitalign
  
  Input:        
  Output:       
  
  Return:        int

  Documentation:    
                    
                    
  History:      Tue May 24 07:02:49 2016



 ***************************************************************************
 ***************************************************************************/
static int check_bitalign (int *bit ) {
    int i,l;
/*     static unsigned char inp[5]; */
    int found=Ssize ;

        found = Ssize;
	Inp[Ssize]= Map[Saddr + Ssize];
        
        for(*bit=0;*bit<8;(*bit)++){
            for (l=1;l<Ssize+1;l++){     
                Inp[l-1] <<=1;
                if(Inp[l] & 0x80U)
                    Inp[l-1] |=1;
            }
            for (i=0;i<Ssize;i++){
            	if(pattern[i] == (Inp[i] & smask[i]) && found){
            		found--;
            		if(!found)
            			MTextSetInt (Search_Bpos, *bit+1);
            	}else if(SearchTyp & INVERTED ){
            		if(pattern[i] == (~(Inp[i]) & smask[i]) && found)
                		found--; 
    	        }
            }
            Inp[Ssize] <<=1;
            if(!found)
            	continue;
            else
            	found=Ssize ;
        }    
	return found;
}
void printout ( int from , int to ) {
   int lim ,lim2, k;
   int address = from , addr;
   char line[76];
   FILE *out;
   char command[256]="a2ps --rows=1 --landscape --medium=A4 "
		     " --columns=1 -l126 --center-title=";
   static char D[16]="0123456789ABCDEF";
 
      
        strcat(command,dumpPath);
   	if(printpath){
        	strcat(command," -o ");
                strcat(command,printpath);
        } 
        strcat (command," 2>/dev/null ");       
   	out=popen(command,"w");
        
   	lim = (to < Map_Size) ? to  :  Map_Size ;

	while(address < lim){
		fprintf(out, " %8.8X | ",address);
                lim2 = ((address+32) < Map_Size) ? address+32 :  Map_Size ;

		for(k=0,addr = address;addr < lim2;addr++){
			line[k++]=D[Map[addr]>>4];
			line[k++]=D[Map[addr] & 0x0f];
			if((addr & 0x03) == 3)
				line[k++]=' ';
		}
                for(;k<72;k++)
                	line[k]=' ';
        	line[k++]='|';
                line[k++]=' ';
		line[k++] = 0; 
                fprintf(out,"%s",line);  	
		for(k=0,addr = address;addr < lim2;addr++){
			if(isprint(Map[addr]) && ! iscntrl(Map[addr]))
				line[k++]=Map[addr];
			else
				line[k++]='.';
			if((addr & 0x03) == 3)
				line[k++]=' ';
		}
		line[k++] = 0;
                fprintf(out,"%s\n",line);  	
		address += 32;
	}
        pclose(out);                
                   	
		        

}

/***************************************************************************
 ***************************************************************************

  Functionname:		Configure_get
  
  Input:		
  Output:   	    	
  
  Return:		void

  Documentation:	read in the rc-file to get saved configuration
  			must be held synchronized with Configure_save_cb


  History:		Sat Dec 27 10:39:49 2008



 ***************************************************************************
 ***************************************************************************/
void Configure_get ( void ) {
  int i=0  , val;
  FILE *sv;
  char  rcfile[256];
  char  key[][16]={"ScrollNum","ScrollAdd","ScrollText","Block_Size",
                   "Hex_Text","Keep_Search","Search_Typ","END",""};
                   
  	strcpy(rcfile,getenv("HOME"));
        strcat(rcfile,"/.HexDumprc");
  	sv = fopen(rcfile,"r");
	if(!sv)
        	return;
	while(fgets(rcfile,255,sv) ){
        	i=0;
        	do{
        		if(!strncmp(key[i],rcfile,strlen(key[i]))){
			     sscanf(&rcfile[strlen(key[i])+1],"%d", &val);
                             switch(i){
                                 case 0:	/*ScrollNum */
                                 scrollnum = val;
                                 break;
                                 case 1:	/* ScrollAdd*/
                                 scrolladd = val;
                                 break;
                                 case 2:	/* ScrollText*/ 
                                 scrolltext = val;
                                 break;
                                 case 3:	/*Block_Size */
                                 Block_Size = val;
                                 break;
                                 case 4:	/*Hex_Text */
                                 Display_Text = val;
                                 break;
                                 case 5:	/*Keep_Search */
                                 Keep_Search = val;
                                 break;
                                 case 6:	/*Search_Typ */
                                 SearchTyp = val;
                                 break;
                              }     
			      break;
                        }	
        	}while(key[++i]);
        }        
}
