/* Created by EasyMotif EasyMotif Release:2_3_8_6  */

/*
 *    Project:    Hex        Path:    ./
 *    Program-name:    Hex
 *    Designer:    J.Keidel        Version:    $Revision: 1.7 $
 *    Description:    Dump a File in Hex and Text
*/

/***************************************************************************
 ***************************************************************************
 *
 *  Projectname:	Hex
 *
 *  Programname:        Hex
 *  
 *  resourcename:	HEx
 *
 *  Designer:		J.Keidel
 *
 *
 *  Documentation:	Dump a File in Hex and Text to scrollable Windows
 *                      on Screen.
 *                      Planned Expansion:  Editing the binary
 *                      Selecting parts and getting checksums/parity etc.
 *                      Searching for Hexnumbers or Patterns
 *			Search for Hexnumbers in different Endianess, or LSB
 *
 *
 *  History:		Wed Nov 26 15:09:21 2008
 *
 *
 *
 ***************************************************************************
 ***************************************************************************/
/* 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public
    License ; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
#include  <stdio.h>
#include  <stdlib.h>
/*     Includes */

#include <Xm/XmAll.h>
#include <XMind.h>
#include <X11/xpm.h>
#include <math.h>
#include  "Hex.h"
/*   PRIVATE INCLUDES   */


/* Global Header */
#include "Hex.h"
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <fcntl.h> 
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>


/*   PRIVATE DEFINES   */
#define VERSION "2.0.0"

/*** PRIVATE HEADER DECLARATIONS ***/
static int      DumpFd   = -1;
static Widget   Toplevel;
static Widget   ScrollNum , ScrollAdd , ScrollText;    /* the three scollbars for sync */

XmTextPosition 	TNstart,TNend;
XmTextPosition 	TXstart,TXend;
int             Keep_Search = FALSE;
int  	        Display_Text = TRUE;
int             scrollnum=1 , scrolladd = 1 , scrolltext = 1;
char            *dumpPath = NULL;
int             Block_Size = MAX_BLOCK;
char            *printpath = NULL;
int             EDITABLE = FALSE; 
unsigned char   *Map      = NULL;
char            *Hex_text=NULL;
char            *Hex_number=NULL;
int             Map_Size = 0;
int    	        Startaddress=0, Endaddress=MAX_BLOCK; /* needed for partial Display (Blockwise) */
FILE            *Log=NULL;

int             Dont = FALSE;

/*** PRIVATE PROTOTYPES  ***/ 


/***  END of HEADER  ***/


/*     GLOBAL WIDGETS */

Widget Hex;
Widget Hex_Number;
Widget Hex_Text;
Widget Hex_control;
Widget Hex_error;
Widget Hex_input;
Widget Hex_Maddress;
Widget Hex_TE_input;
Widget Search_Bpos;

/*     GLOBAL Graphics */


/*    STATIC GLOBAL WIDGETS */

static Widget Hex_increm;
static Widget Hex_decrem;
static Widget Hex_Searching;
static Widget Address;
static Widget Hex_edit;
static Widget Error;
static Widget Search_pattern;
static Widget Search_mask;
static Widget Search_find;
static Widget Extract_from;
static Widget Extract_to;
static Widget Extract_path;
static Widget About_Tf24;

/*    STATIC GLOBAL Graphics */


/*    Prototypes */

Widget Hex_Create (Widget parent );
Widget Error_Create (Widget parent , char *message );
static Widget address_Create (Widget parent );
static Widget Search_Create (Widget parent , Position xp,int yp );
static Widget Configure_Create (Widget parent );
static Widget Extract_Create (Widget parent );
static Widget About_Create (Widget parent );

/*    CALLBACKS */
static void selectFile_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void quit_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void extract_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void about_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void redisplay_cb (Widget parent , int data , XmPushButtonCallbackStruct *  cbs);
static void get_got_address_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void search_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void setlogfile_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void printactual_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void printall_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void get_printfile_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void configure_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void Toggle_edit_cb (Widget parent , XtPointer data , XmToggleButtonCallbackStruct *  cbs);
static void change_now_cb (Widget parent , XtPointer data , XmTextVerifyCallbackStruct *  cbs);
static void addr_increm_cb (Widget parent , int data , XmPushButtonCallbackStruct *  cbs);
static void change_now_TE_cb (Widget parent , XtPointer data , XmTextVerifyCallbackStruct *  cbs);
static void errorquit_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void goto_address_cb (Widget parent , XtPointer data , XmTextVerifyCallbackStruct *  cbs);
static void search_act_cb (Widget parent , XtPointer data , XmTextVerifyCallbackStruct *  cbs);
static void inverted_cb (Widget parent , XtPointer data , XmToggleButtonCallbackStruct *  cbs);
static void set_searchtyp_cb (Widget parent , int data , XmToggleButtonCallbackStruct *  cbs);
static void findit_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void done_search_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void find_next_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void search_keep_cb (Widget parent , XtPointer data , XmToggleButtonCallbackStruct *  cbs);
static void configure_scrollbar_cb (Widget parent , int data , XmToggleButtonCallbackStruct *  cbs);
static void configure_done_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void Configure_size_cb (Widget parent , XtPointer data , XmTextVerifyCallbackStruct *  cbs);
static void set_text_display_cb (Widget parent , XtPointer data , XmToggleButtonCallbackStruct *  cbs);
static void Configure_save_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void do_extract_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void extract_cancel_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void Version_cb (Widget parent , XtPointer data , XmTextVerifyCallbackStruct *  cbs);

/*    EVENT HANDLERS */
static void selection_ev (Widget parent, int clientData, XEvent *event, Boolean *continueToDispatch);

/*    FUNCTIONS */

static void get_Hex_file ( char *path ) ;
static void Address_line ( int address ) ;
static void Hex_line ( int address ) ;
static void text_line ( int address ) ;
static void Move_cb ( Widget parent, XtPointer data , XmScrollBarCallbackStruct * cbs  ) ;
static void remap ( void ) ;
static void open_logfile ( char *path ) ;
static void get_printfile ( char *path  ) ;


/*  FALLBACK RESOURCES */
 static String fallback_resources[] = { 
"*fontList: 7x13",
"*Highlight:  cyan",
"*help.background:  PaleGreen",
"HEx*HEX.fontList: -adobe-courier-*-r-*-*-12-*-*-*-*-*-*-*",
"HEx*Form1.Toggle_1.background: linen",
"HEx*Form1*Textfield_8.background: linen",
"HEx*Form1*Pushbutton_2.foreground: blue",
"HEx*Form1*Pushbutton_3.foreground: blue",
"HEx*Form1*Textfield_23.background: linen",
"HEx*Menu.shadowThickness: 3",
"HEx*Menu.background: MediumAquamarine",
"HEx*Menu.topShadowColor: LightCyan",
"HEx*Menu.fontList: -adobe-*-bold-r-*-*-15-*-*-*-*-*-*-*",
"HEx*Menu.borderColor: grey54",
"HEx*Menu.borderWidth: 1",
"HEx*error.fontList: -adobe-*-bold-r-*-*-19-*-*-*-*-*-*-*",
"HEx*error.foreground: brown1",
"HEx*Form12*Pushbutton_9.background: ForestGreen",
"HEx*Form12*Pushbutton_9.fontList: -adobe-*-bold-r-*-*-12-*-*-*-*-*-*-*",
  NULL 
};


/***************************************************************************
 ***************************************************************************
 *
 *  Dialog function:	Hex
 *
 ***************************************************************************
 *  
 *  Input:		
 *
 *  Return:		Widget Hex
 *
 *  Documentation:	Main Window, displaying Address, Hexadecimal dump
 *                      and Text of a file.
 *                      Pulldown menu to select the file.
 *
 *  
 *  History:		Wed Nov 26 15:13:38 2008
 *
 *
 *
 ***************************************************************************
 ***************************************************************************/

Widget Hex_Create (Widget parent ){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget Pulldown_Menubar;
Widget Hex_Ca1;
Widget Hex_Ca1_Ca2;
Widget Hex_Ca1_Ca3;
Widget Hex_Ca1_Ca19;
Widget Hex_Ca20;
Widget Hex_Ca6_Ca7;
Widget Hex_Ca6_Ca10;
Widget Hex_Ca11;
Widget Hex_Ca15;
Widget Hex_Ca15_Ca16;
Widget Hex_Ca15_Ca17;
Widget Hex_Ca15_Ca18;
Widget Hex_Ca14;
Widget Hex_address;
Widget F_Hex_address;
Widget Hex_address_La3;
Widget Hex_hex;
Widget F_Hex_hex;
Widget Hex_hex_La4;
Widget Hex_text;
Widget F_Hex_text;
Widget Hex_text_La5;
Widget Hex_help;
Widget Hex_Pu2;
Widget Hex_Pu3;

   /* Main Dialog */

    n=0;
/* Icon Pixmap */
/* pixmap at included */

     {
#include "Hex_small.xpm"
        Pixmap IconPixmap;
        int status;            /* XPM return status              */

        status = XpmCreatePixmapFromData(XtDisplay(parent), RootWindowOfScreen(XtScreen(parent)),
                       Hex_small, &IconPixmap, NULL, NULL);
        if (status != XpmSuccess) IconPixmap = (Pixmap) NULL;
        if (!(IconPixmap)) XtWarning("Wrong pixmap: Hex_small.xpm");
        else {
          XtSetArg(args[n], XmNiconPixmap, IconPixmap); n++;
        }
    }
    XtSetValues(parent, args, n);    n = 0;
     XtSetArg(args[n], XmNwidth, 997); n++;
    XtSetArg(args[n], XmNheight, 502); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, FALSE); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
       XtSetArg(args[n], XmNwidth,997 ); n++;
       XtSetArg(args[n], XmNheight,502 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    Hex = GrCreateForm(parent, "Form1", args, n);

/*  PULLDOWN MENU */
    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    Pulldown_Menubar = XmCreateMenuBar(Hex, "menuBar", args, n);
    XtManageChild(Pulldown_Menubar);

    n=0;
    tmpLabelString =  XmStringCreate("File", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca1 = XmCreateCascadeButton(Pulldown_Menubar, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca1);
    {
    Widget Hex_Ca1_SubId;
    Hex_Ca1_SubId = XmCreatePulldownMenu(Pulldown_Menubar, "Menu", NULL, 0);

    n=0;
    tmpLabelString =  XmStringCreate("Dump File", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca1_Ca2 = XmCreatePushButton(Hex_Ca1_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca1_Ca2);

    n=0;
    tmpLabelString =  XmStringCreate("QUIT", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca1_Ca3 = XmCreatePushButton(Hex_Ca1_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca1_Ca3);

    n=0;
    tmpLabelString =  XmStringCreate("Extract part", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca1_Ca19 = XmCreatePushButton(Hex_Ca1_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca1_Ca19);
    XtVaSetValues(Hex_Ca1, XmNsubMenuId, Hex_Ca1_SubId, NULL);
    XtManageChild(Hex_Ca1);
    }

    n=0;
    tmpLabelString =  XmStringCreate("About", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca20 = XmCreateCascadeButton(Pulldown_Menubar, "Cascade_20", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca20);

    XtVaSetValues(Pulldown_Menubar,  XmNmenuHelpWidget, Hex_Ca20, NULL);

    n=0;
    tmpLabelString =  XmStringCreate("NEXT", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
/* Label Pixmap */
/* pixmap at included */

     {
#include "down.xpm"
        Pixmap LabelPixmap;
        int status;            /* XPM return status              */

        status = XpmCreatePixmapFromData(XtDisplay(parent), RootWindowOfScreen(XtScreen(parent)),
                       down_xpm, &LabelPixmap, NULL, NULL);
        if (status != XpmSuccess) LabelPixmap = (Pixmap) NULL;
        if (!(LabelPixmap)) XtWarning("Wrong pixmap: down.xpm");
        else {
          XtSetArg(args[n], XmNlabelPixmap, LabelPixmap); n++;
          XtSetArg(args[n], XmNlabelType, XmPIXMAP); n++;
        }
    }
    Hex_increm = XmCreateCascadeButton(Pulldown_Menubar, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_increm);

    n=0;
    tmpLabelString =  XmStringCreate("PREV", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
/* Label Pixmap */
/* pixmap at included */

     {
#include "up.xpm"
        Pixmap LabelPixmap;
        int status;            /* XPM return status              */

        status = XpmCreatePixmapFromData(XtDisplay(parent), RootWindowOfScreen(XtScreen(parent)),
                       up_xpm, &LabelPixmap, NULL, NULL);
        if (status != XpmSuccess) LabelPixmap = (Pixmap) NULL;
        if (!(LabelPixmap)) XtWarning("Wrong pixmap: up.xpm");
        else {
          XtSetArg(args[n], XmNlabelPixmap, LabelPixmap); n++;
          XtSetArg(args[n], XmNlabelType, XmPIXMAP); n++;
        }
    }
    Hex_decrem = XmCreateCascadeButton(Pulldown_Menubar, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_decrem);

    n=0;
    tmpLabelString =  XmStringCreate("Search", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Searching = XmCreateCascadeButton(Pulldown_Menubar, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Searching);
    {
    Widget Hex_Searching_SubId;
    Hex_Searching_SubId = XmCreatePulldownMenu(Pulldown_Menubar, "Menu", NULL, 0);

    n=0;
    tmpLabelString =  XmStringCreate("Goto Address", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca6_Ca7 = XmCreatePushButton(Hex_Searching_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca6_Ca7);

    n=0;
    tmpLabelString =  XmStringCreate("Search Pattern", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca6_Ca10 = XmCreatePushButton(Hex_Searching_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca6_Ca10);
    XtVaSetValues(Hex_Searching, XmNsubMenuId, Hex_Searching_SubId, NULL);
    XtManageChild(Hex_Searching);
    }

    n=0;
    tmpLabelString =  XmStringCreate("Log-Search", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca11 = XmCreateCascadeButton(Pulldown_Menubar, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca11);

    n=0;
    tmpLabelString =  XmStringCreate("Print", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca15 = XmCreateCascadeButton(Pulldown_Menubar, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca15);
    {
    Widget Hex_Ca15_SubId;
    Hex_Ca15_SubId = XmCreatePulldownMenu(Pulldown_Menubar, "Menu", NULL, 0);

    n=0;
    tmpLabelString =  XmStringCreate("Actual range", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca15_Ca16 = XmCreatePushButton(Hex_Ca15_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca15_Ca16);

    n=0;
    tmpLabelString =  XmStringCreate("All", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca15_Ca17 = XmCreatePushButton(Hex_Ca15_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca15_Ca17);

    n=0;
    tmpLabelString =  XmStringCreate("Printfile", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca15_Ca18 = XmCreatePushButton(Hex_Ca15_SubId, "Menu", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca15_Ca18);
    XtVaSetValues(Hex_Ca15, XmNsubMenuId, Hex_Ca15_SubId, NULL);
    XtManageChild(Hex_Ca15);
    }

    n=0;
    tmpLabelString =  XmStringCreate("Configure", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_Ca14 = XmCreateCascadeButton(Pulldown_Menubar, "Cascade_14", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_Ca14);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNwidth, 102); n++;
    XtSetArg(args[n], XmNheight, 380); n++;
    XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
    F_Hex_address= XmCreateFrame(Hex, "frame", args, n);
    XtManageChild(F_Hex_address);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNwidth, 102); n++;
    XtSetArg(args[n], XmNheight, 380); n++;
    Hex_address = GrCreateForm(F_Hex_address, "Form_3", args, n);
    XtManageChild(Hex_address);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 30); n++;
    XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT ); n++;
    XtSetArg(args[n], XmNwidth, 102); n++;
    XtSetArg(args[n], XmNheight, 350); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    XtSetArg(args[n], XmNscrollHorizontal, FALSE); n++;
    XtSetArg(args[n], XmNscrollVertical, TRUE); n++;
    Address = XmCreateScrolledText(Hex_address, "HEX", args, n);
    XtManageChild(Address);
    XmTextSetString(Address, " \n");

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 102); n++;
    XtSetArg(args[n], XmNheight, 30); n++;
    tmpLabelString = XmStringCreateLtoR("Address", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_address_La3 = XmCreateLabel(Hex_address, "Address", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_address_La3);

    n=0;
     XtSetArg(args[n], XmNx, 102); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNwidth, 546); n++;
    XtSetArg(args[n], XmNheight, 380); n++;
    XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
    F_Hex_hex= XmCreateFrame(Hex, "frame", args, n);
    XtManageChild(F_Hex_hex);

    n=0;
     XtSetArg(args[n], XmNx, 102); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNwidth, 546); n++;
    XtSetArg(args[n], XmNheight, 380); n++;
    Hex_hex = GrCreateForm(F_Hex_hex, "Form_4", args, n);
    XtManageChild(Hex_hex);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n],XmNrightOffset ,5);n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 30); n++;
    XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT ); n++;
    XtSetArg(args[n], XmNwidth, 546); n++;
    XtSetArg(args[n], XmNheight, 350); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    XtSetArg(args[n], XmNscrollHorizontal, FALSE); n++;
    XtSetArg(args[n], XmNscrollVertical, TRUE); n++;
    Hex_Number = XmCreateScrolledText(Hex_hex, "HEX", args, n);
    XtManageChild(Hex_Number);
    XmTextSetString(Hex_Number, " ");

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 546); n++;
    XtSetArg(args[n], XmNheight, 30); n++;
    tmpLabelString = XmStringCreateLtoR("Hexadecimal dump", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_hex_La4 = XmCreateLabel(Hex_hex, "Label_4", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_hex_La4);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 648); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNwidth, 349); n++;
    XtSetArg(args[n], XmNheight, 380); n++;
    XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
    F_Hex_text= XmCreateFrame(Hex, "frame", args, n);
    XtManageChild(F_Hex_text);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 648); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNwidth, 349); n++;
    XtSetArg(args[n], XmNheight, 380); n++;
    Hex_text = GrCreateForm(F_Hex_text, "Form_5", args, n);
    XtManageChild(Hex_text);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 30); n++;
    XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT ); n++;
    XtSetArg(args[n], XmNwidth, 349); n++;
    XtSetArg(args[n], XmNheight, 350); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    XtSetArg(args[n], XmNscrollHorizontal, FALSE); n++;
    XtSetArg(args[n], XmNscrollVertical, TRUE); n++;
    Hex_Text = XmCreateScrolledText(Hex_text, "HEX", args, n);
    XtManageChild(Hex_Text);
    XmTextSetString(Hex_Text, " ");

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 349); n++;
    XtSetArg(args[n], XmNheight, 30); n++;
    tmpLabelString = XmStringCreateLtoR("Translated text", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Hex_text_La5 = XmCreateLabel(Hex_text, "Label_5", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_text_La5);

    n=0;
     XtSetArg(args[n], XmNx, 168); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 95); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Hex_control = XmCreateTextField(Hex, "Textfield_5", args, n);
    XtManageChild(Hex_control);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
#endif
     XtSetArg(args[n], XmNx, 478); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 389); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Hex_error = XmCreateTextField(Hex, "error", args, n);
    XtManageChild(Hex_error);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
    XtSetArg(args[n], XmNx, 867); n++;
    XtSetArg(args[n], XmNy, 49); n++;
    tmpLabelString = XmStringCreateLtoR("Editable", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 130); n++;
    XtSetArg(args[n], XmNheight, 34); n++;
    Hex_edit = XmCreateToggleButton(Hex, "Toggle_1", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Hex_edit);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 465); n++;
    XtSetArg(args[n], XmNwidth, 997); n++;
    XtSetArg(args[n], XmNcursorPositionVisible,False);n++;
    XtSetArg(args[n], XmNtraversalOn,False);n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Hex_help = XmCreateTextField(Hex, "help", args, n);
    XtManageChild(Hex_help);

    n=0;
     XtSetArg(args[n], XmNx, 271); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 86); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Hex_input = XmCreateTextField(Hex, "Textfield_8", args, n);
    XtManageChild(Hex_input);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNleftOffset ,10);n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 102); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Hex_Maddress = XmCreateTextField(Hex, "Textfield_11", args, n);
    XtManageChild(Hex_Maddress);

    n=0;
    XtSetArg(args[n], XmNx, 112); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 24); n++;
    XtSetArg(args[n], XmNheight, 39); n++;
    XtSetArg(args[n], XmNmultiClick, XmMULTICLICK_DISCARD); n++;
    XtSetArg(args[n], XmNarrowDirection, 0); n++;
    Hex_Pu2 = XmCreateArrowButton( Hex, "Pushbutton_2", args, n);
    XtManageChild(Hex_Pu2);

    n=0;
    XtSetArg(args[n], XmNx, 140); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 24); n++;
    XtSetArg(args[n], XmNheight, 39); n++;
    XtSetArg(args[n], XmNmultiClick, XmMULTICLICK_DISCARD); n++;
    XtSetArg(args[n], XmNarrowDirection, 1); n++;
    Hex_Pu3 = XmCreateArrowButton( Hex, "Pushbutton_3", args, n);
    XtManageChild(Hex_Pu3);

    n=0;
     XtSetArg(args[n], XmNx, 367); n++;
    XtSetArg(args[n], XmNy, 46); n++;
    XtSetArg(args[n], XmNwidth, 86); n++;
    XtSetArg(args[n], XmNmaxLength,5 ); n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Hex_TE_input = XmCreateTextField(Hex, "Textfield_23", args, n);
    XtManageChild(Hex_TE_input);

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Hex_control);n++;
    XtSetArg(args[n],XmNbottomOffset ,0);n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNbottomWidget,Hex_help);n++;
    XtSetValues(F_Hex_address, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Hex_control);n++;
    XtSetArg(args[n],XmNbottomOffset ,0);n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNbottomWidget,Hex_help);n++;
    XtSetArg(args[n],XmNleftOffset ,0);n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNleftWidget,F_Hex_address);n++;
    XtSetValues(F_Hex_hex, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Hex_control);n++;
    XtSetArg(args[n],XmNbottomOffset ,0);n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNbottomWidget,Hex_help);n++;
    XtSetArg(args[n],XmNleftOffset ,5);n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNleftWidget,F_Hex_hex);n++;
    XtSetValues(F_Hex_text, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget, Pulldown_Menubar);n++;
    XtSetValues(Hex_control, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget, Pulldown_Menubar);n++;
    XtSetArg(args[n],XmNrightOffset ,20);n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNrightWidget,Hex_edit);n++;
    XtSetValues(Hex_error, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget, Pulldown_Menubar);n++;
    XtSetValues(Hex_edit, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget, Pulldown_Menubar);n++;
    XtSetValues(Hex_input, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,1);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget, Pulldown_Menubar);n++;
    XtSetValues(Hex_TE_input, args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Hex_text_La5);n++;
    XtSetValues(XtParent(Hex_Text), args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Hex_hex_La4);n++;
    XtSetValues(XtParent(Hex_Number), args, n);

#endif

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Hex_address_La3);n++;
    XtSetValues(XtParent(Address), args, n);

#endif

    /*  create graphics */

    /*  create additional attaches */
    XtAddCallback(Hex_Ca20, XmNactivateCallback,(XtCallbackProc)about_cb,(XtPointer)NULL );
    XtAddCallback(Hex_increm, XmNactivateCallback,(XtCallbackProc)redisplay_cb,(XtPointer)(long int)1 );
    XtAddCallback(Hex_decrem, XmNactivateCallback,(XtCallbackProc)redisplay_cb,(XtPointer)(long int)-1 );
    XtAddCallback(Hex_Ca11, XmNactivateCallback,(XtCallbackProc)setlogfile_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca14, XmNactivateCallback,(XtCallbackProc)configure_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca15_Ca16, XmNactivateCallback,(XtCallbackProc)printactual_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca15_Ca17, XmNactivateCallback,(XtCallbackProc)printall_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca15_Ca18, XmNactivateCallback,(XtCallbackProc)get_printfile_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca6_Ca7, XmNactivateCallback,(XtCallbackProc)get_got_address_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca6_Ca10, XmNactivateCallback,(XtCallbackProc)search_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca1_Ca2, XmNactivateCallback,(XtCallbackProc)selectFile_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca1_Ca3, XmNactivateCallback,(XtCallbackProc)quit_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Ca1_Ca19, XmNactivateCallback,(XtCallbackProc)extract_cb,(XtPointer)NULL );

    /*  add all callbacks */
    XtAddCallback(Hex_edit, XmNvalueChangedCallback,(XtCallbackProc)Toggle_edit_cb,(XtPointer)NULL );
    XtAddCallback(Hex_input, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(Hex_input, XmNactivateCallback,(XtCallbackProc)change_now_cb,(XtPointer)NULL );
    XtAddCallback(Hex_Pu2, XmNactivateCallback,(XtCallbackProc)addr_increm_cb,(XtPointer)(long int)-4 );
    XtAddCallback(Hex_Pu3, XmNactivateCallback,(XtCallbackProc)addr_increm_cb,(XtPointer)(long int)4 );
    XtAddCallback(Hex_TE_input, XmNactivateCallback,(XtCallbackProc)change_now_TE_cb,(XtPointer)NULL );
    XtAddEventHandler(Hex_Text, ButtonReleaseMask, False, (XtEventHandler)selection_ev, (XtPointer)(long int)2);
    XtAddEventHandler(Hex_Number, ButtonReleaseMask, False, (XtEventHandler)selection_ev, (XtPointer)(long int)1);

/* Hex FINIT-function */
/*
 * 	XmTextSetAddMode(Hex_Number,TRUE);
 * 	XmTextSetAddMode(Hex_Text,TRUE);
 */
/* get the Widget ID of all three scrolled text widgets's Scrollbar */        
	XtVaGetValues(XtParent (Address),XmNverticalScrollBar,&ScrollAdd,NULL);
	XtVaGetValues(XtParent (Hex_Number),XmNverticalScrollBar,&ScrollNum,NULL);
	XtVaGetValues(XtParent (Hex_Text),XmNverticalScrollBar,&ScrollText,NULL);
/* now add scrollbar moving callbacks to all the scrollbars, reflecting the move to the others */        

       XtAddCallback(ScrollAdd, XmNdragCallback,(XtCallbackProc)Move_cb,(XtPointer)0 );
       XtAddCallback(ScrollAdd, XmNincrementCallback,(XtCallbackProc)Move_cb,(XtPointer)0 );
       XtAddCallback(ScrollAdd, XmNdecrementCallback,(XtCallbackProc)Move_cb,(XtPointer)0 );
       XtAddCallback(ScrollText, XmNdragCallback,(XtCallbackProc)Move_cb,(XtPointer)1 );
       XtAddCallback(ScrollText, XmNincrementCallback,(XtCallbackProc)Move_cb,(XtPointer)1 );
       XtAddCallback(ScrollText, XmNdecrementCallback,(XtCallbackProc)Move_cb,(XtPointer)1 );
       XtAddCallback(ScrollNum, XmNdragCallback,(XtCallbackProc)Move_cb,(XtPointer)2 );
       XtAddCallback(ScrollNum, XmNincrementCallback,(XtCallbackProc)Move_cb,(XtPointer)2 );
       XtAddCallback(ScrollNum, XmNdecrementCallback,(XtCallbackProc)Move_cb,(XtPointer)2 );
       XtAddCallback(ScrollAdd, XmNvalueChangedCallback,(XtCallbackProc)Move_cb,(XtPointer)0 );
       XtAddCallback(ScrollText, XmNvalueChangedCallback,(XtCallbackProc)Move_cb,(XtPointer)1 );
       XtAddCallback(ScrollNum, XmNvalueChangedCallback,(XtCallbackProc)Move_cb,(XtPointer)2 );
       XtAddCallback(ScrollAdd, XmNpageIncrementCallback,(XtCallbackProc)Move_cb,(XtPointer)0 );
       XtAddCallback(ScrollText, XmNpageIncrementCallback,(XtCallbackProc)Move_cb,(XtPointer)1 );
       XtAddCallback(ScrollNum, XmNpageIncrementCallback,(XtCallbackProc)Move_cb,(XtPointer)2 );
       XtAddCallback(ScrollAdd, XmNpageDecrementCallback,(XtCallbackProc)Move_cb,(XtPointer)0 );
       XtAddCallback(ScrollText, XmNpageDecrementCallback,(XtCallbackProc)Move_cb,(XtPointer)1 );
       XtAddCallback(ScrollNum, XmNpageDecrementCallback,(XtCallbackProc)Move_cb,(XtPointer)2 );

/* indeed, we need only one scrollbar, so unmanage the others, it's easier to handle */        

	if(!scrollnum)
     		XtUnmanageChild(ScrollNum);
        if(!scrolladd)      
     		XtUnmanageChild(ScrollText);
        if(!scrolltext) 
     		XtUnmanageChild(ScrollAdd); 

/* may sometimes later, we will need the other scrollbars, so just manage them again */             


       XtSetSensitive(Hex_decrem,FALSE);
       XtSetSensitive(Hex_increm,FALSE);
       XtSetSensitive(Hex_Searching,FALSE);       

/* Be sure, that everything to be cleaned, is done at each type of terminating Hex-Dump */
	MGrabDelete (Hex_Number, quit_cb, NULL);  
        
/* may be we reconfigure the size via rcfile */
	if(!Display_Text ){
		XtVaSetValues(Toplevel,XmNwidth, 997 -350,NULL);                
		XtVaSetValues(Hex,XmNwidth, 997 -350,NULL);                
		XtUnmanageChild(Hex_Text);
	}        	     
        
    EAddQuickHelp (Hex_help , Hex_Ca1_Ca2 , "Select the File to be dumped");
    EAddQuickHelp (Hex_help , Hex_increm , "Display next block of Adresses");
    EAddQuickHelp (Hex_help , Hex_decrem , "Display previous Block of addresses");
    EAddQuickHelp (Hex_help , Hex_Searching , "Menu to do searching or jumping");
    EAddQuickHelp (Hex_help , Hex_Ca11 , "Start a log file for searches");
    EAddQuickHelp (Hex_help , Address , "Display of the byte Address of first word in line of Dump");
    EAddQuickHelp (Hex_help , Hex_Number , "Display of 32 Bytes in Hex, grouped to 4 Bytes (8Digits)");
    EAddQuickHelp (Hex_help , Hex_Text , "Display of 32 Bytes as Text, grouped to 4 Bytes");
    EAddQuickHelp (Hex_help , Hex_control , "Control display of original word");
    EAddQuickHelp (Hex_help , Hex_error , "Error messages");
    EAddQuickHelp (Hex_help , Hex_edit , "Switch between display and edit mode");
    EAddQuickHelp (Hex_help , Hex_input , "Modification value");
    EAddQuickHelp (Hex_help , Hex_Maddress , "displays selected address");
    EAddQuickHelp (Hex_help , Hex_Pu2 , "decrements Address by 4 bytes");
    EAddQuickHelp (Hex_help , Hex_Pu3 , "increments address by four bytes");
    EAddQuickHelp (Hex_help , Hex_TE_input , "If selected from Text dislay, shows the Text");
    XtManageChild(Hex);
    return Hex;
}


/***************************************************************************
 ***************************************************************************
 *
 *  Dialog function:	Error
 *
 ***************************************************************************
 *  
 *  Input:		char *message
 *
 *  Return:		Widget Error
 *
 *  Documentation:	Error dialog, displays the given Message and waits
 *                      MODAL until the quit-button pressed.
 *
 *  
 *  History:		Fri Dec 12 10:07:02 2008
 *
 *
 ***************************************************************************
 ***************************************************************************/

Widget Error_Create (Widget parent ,char *message){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget MainShell;
Widget Error_error;
Widget Error_Pu1;
    n = 0;
    XtSetArg(args[n], XmNwidth, 500); n++;
    XtSetArg(args[n], XmNheight, 97); n++;
    XtSetArg(args[n], XmNtitle, "ERROR"); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    MainShell = (Widget)XmCreateDialogShell(XtParent(parent),"Form6_Dialog",args, n);

    n = 0;
     XtSetArg(args[n], XmNwidth, 500); n++;
    XtSetArg(args[n], XmNheight, 97); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, FALSE); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
       XtSetArg(args[n], XmNwidth,500 ); n++;
       XtSetArg(args[n], XmNheight,97 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    Error = GrCreateForm(MainShell, "Form6", args, n);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 8); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 485); n++;
    XtSetArg(args[n], XmNheight, 42); n++;
    tmpLabelString = XmStringCreateLtoR("", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Error_error = XmCreateLabel(Error, "error", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Error_error);

    n=0;
    XtSetArg(args[n], XmNx, 204); n++;
    XtSetArg(args[n], XmNy, 42); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 93); n++;
    XtSetArg(args[n], XmNheight, 39); n++;
    tmpLabelString = XmStringCreateLtoR("quit", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Error_Pu1 = XmCreatePushButton(Error, "Pushbutton_1", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Error_Pu1);

/*   Generate additional attachments   */
    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n],XmNtopOffset ,0);n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );n++;
    XtSetArg(args[n], XmNtopWidget,Error_error);n++;
    XtSetValues(Error_Pu1, args, n);

#endif

    /*  create graphics */

    /*  create additional attaches */

    /*  add all callbacks */
    XtAddCallback(Error_Pu1, XmNactivateCallback,(XtCallbackProc)errorquit_cb,(XtPointer)NULL );

/* Error FINIT-function */
	tmpLabelString = XmStringCreateLtoR(message, XmFONTLIST_DEFAULT_TAG);
	XtVaSetValues(Error_error,XmNlabelString, tmpLabelString,NULL);
        
    XtManageChild(Error);
    XtManageChild(MainShell);
    return Error;
}


/***************************************************************************
 ***************************************************************************
 *
 *  Dialog function:	address
 *
 ***************************************************************************
 *  
 *  Input:		
 *
 *  Return:		Widget address
 *
 *  Documentation:	input of address to display next
 *
 *  
 *  History:		Sun Dec 14 10:21:14 2008

 *
 *
 ***************************************************************************
 ***************************************************************************/

static Widget address_Create (Widget parent ){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget MainShell;
  Widget address;
Widget address_Tf12;
Widget address_La7;
    n = 0;
    XtSetArg(args[n], XmNwidth, 173); n++;
    XtSetArg(args[n], XmNheight, 70); n++;
    XtSetArg(args[n], XmNtitle, "Address"); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    MainShell = (Widget)XmCreateDialogShell(XtParent(parent),"Form7_Dialog",args, n);

    n = 0;
     XtSetArg(args[n], XmNwidth, 173); n++;
    XtSetArg(args[n], XmNheight, 70); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, FALSE); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
       XtSetArg(args[n], XmNwidth,173 ); n++;
       XtSetArg(args[n], XmNheight,70 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    address = GrCreateForm(MainShell, "Form7", args, n);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 32); n++;
    XtSetArg(args[n], XmNwidth, 173); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    address_Tf12 = XmCreateTextField(address, "Textfield_12", args, n);
    XtManageChild(address_Tf12);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 173); n++;
    XtSetArg(args[n], XmNheight, 29); n++;
    tmpLabelString = XmStringCreateLtoR("goto address", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    address_La7 = XmCreateLabel(address, "Label_7", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(address_La7);

    /*  create graphics */

    /*  create additional attaches */

    /*  add all callbacks */
    XtAddCallback(address_Tf12, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(address_Tf12, XmNactivateCallback,(XtCallbackProc)goto_address_cb,(XtPointer)NULL );
    XtManageChild(address);
    XtManageChild(MainShell);
    return address;
}

/*************************************************************************** 
 * 
 * Funktionsname:  Search_Create
 * 
 * 
 * Input:          Widget parent
 * 
 * Return:         Widget 
 * 
 * Dokumentation:  
 * 
 * 
 ***************************************************************************/

static Widget Search_Create (Widget parent ,Position xp,int yp){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget MainShell;
  Widget Search;
Widget Search_help;
Widget Search_La8;
Widget Search_La9;
Widget Search_Fo9;
Widget F_Search_Fo9;
Widget Search_inverted;
Widget Search_Fo9_Ra1;
Widget F_Search_Fo9_Ra1;
Widget Search_byte;
Widget Search_word;
Widget Search_bit;
Widget Search_Pu5;
Widget Search_Pu6;
Widget Search_keep;

/* Search INIT-Function*/

    n = 0;
    XtSetArg(args[n], XmNwidth, 344); n++;
    XtSetArg(args[n], XmNheight, 228); n++;
    XtSetArg(args[n], XmNtitle, "Search"); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
{
  Dimension   xw,yh;
  Arg pargs[10];
  Cardinal pn;	
    pn=0;
    XtSetArg(pargs[pn],XmNx , &xw);pn++;
    XtSetArg(pargs[pn],XmNy , &yh);pn++;
    XtGetValues(XtParent(parent) , pargs,pn);
    XtSetArg(args[n], XmNx, xw+xp); n++;
    XtSetArg(args[n], XmNy, yh+yp); n++; 
}
    MainShell = (Widget)XmCreateDialogShell(XtParent(parent),"Form8_Dialog",args, n);

    n = 0;
     XtSetArg(args[n], XmNwidth, 344); n++;
    XtSetArg(args[n], XmNheight, 228); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, TRUE); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, FALSE); n++;
       XtSetArg(args[n], XmNwidth,344 ); n++;
       XtSetArg(args[n], XmNheight,228 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    Search = GrCreateForm(MainShell, "Form8", args, n);
    n=0;
    XtSetArg(args[n], XmNmaxWidth,344 );n++;
    XtSetArg(args[n], XmNminWidth,344 );n++;
    XtSetArg(args[n], XmNmaxHeight,228 );n++;
    XtSetArg(args[n], XmNminHeight,228 );n++;
    XtSetValues(XtParent(Search),args, n);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 193); n++;
    XtSetArg(args[n], XmNwidth, 344); n++;
    XtSetArg(args[n], XmNcursorPositionVisible,False);n++;
    XtSetArg(args[n], XmNtraversalOn,False);n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Search_help = XmCreateTextField(Search, "help", args, n);
    XtManageChild(Search_help);

    n=0;
     XtSetArg(args[n], XmNx, 95); n++;
    XtSetArg(args[n], XmNy, 2); n++;
    XtSetArg(args[n], XmNwidth, 82); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    Search_pattern = XmCreateTextField(Search, "Textfield_14", args, n);
    XtManageChild(Search_pattern);

    n=0;
     XtSetArg(args[n], XmNx, 9); n++;
    XtSetArg(args[n], XmNy, 2); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 73); n++;
    XtSetArg(args[n], XmNheight, 33); n++;
    tmpLabelString = XmStringCreateLtoR("search for", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Search_La8 = XmCreateLabel(Search, "Label_8", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_La8);

    n=0;
     XtSetArg(args[n], XmNx, 195); n++;
    XtSetArg(args[n], XmNy, 3); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 51); n++;
    XtSetArg(args[n], XmNheight, 33); n++;
    tmpLabelString = XmStringCreateLtoR("Mask", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Search_La9 = XmCreateLabel(Search, "Label_9", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_La9);

    n=0;
     XtSetArg(args[n], XmNx, 255); n++;
    XtSetArg(args[n], XmNy, 3); n++;
    XtSetArg(args[n], XmNwidth, 82); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    Search_mask = XmCreateTextField(Search, "Textfield_15", args, n);
    XtManageChild(Search_mask);
    XmTextSetString(Search_mask, "FFFFFFFF");

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
#endif
     XtSetArg(args[n], XmNx, 14); n++;
    XtSetArg(args[n], XmNy, 35); n++;
    XtSetArg(args[n], XmNwidth, 155); n++;
    XtSetArg(args[n], XmNheight, 151); n++;
    XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
    F_Search_Fo9= XmCreateFrame(Search, "frame", args, n);
    tmpLabelString =  XmStringCreate("Search options ", XmSTRING_DEFAULT_CHARSET);
    XtVaCreateManagedWidget("Search options ",
    xmLabelGadgetClass, F_Search_Fo9,XmNchildType, XmFRAME_TITLE_CHILD,
    XmNlabelString, tmpLabelString,
    XmNchildVerticalAlignment, XmALIGNMENT_BASELINE_TOP,
    XmNchildHorizontalAlignment,  1,
    NULL);
    XmStringFree(tmpLabelString);
    XtManageChild(F_Search_Fo9);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
#endif
     XtSetArg(args[n], XmNx, 14); n++;
    XtSetArg(args[n], XmNy, 35); n++;
    XtSetArg(args[n], XmNwidth, 155); n++;
    XtSetArg(args[n], XmNheight, 151); n++;
    Search_Fo9 = GrCreateForm(F_Search_Fo9, "Form_9", args, n);
    XtManageChild(Search_Fo9);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
#endif
    XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, -1); n++;
    tmpLabelString = XmStringCreateLtoR("and inverted", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 137); n++;
    XtSetArg(args[n], XmNheight, 27); n++;
    XtSetArg(args[n], XmNalignment, 0 ); n++;
    Search_inverted = XmCreateToggleButton(Search_Fo9, "Toggle_3", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_inverted);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 33); n++;
    XtSetArg(args[n], XmNwidth, 155); n++;
    XtSetArg(args[n], XmNheight, 118); n++;
    XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
    F_Search_Fo9_Ra1= XmCreateFrame(Search_Fo9, "frame", args, n);
    XtManageChild(F_Search_Fo9_Ra1);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 33); n++;
    XtSetArg(args[n], XmNwidth, 155); n++;
    XtSetArg(args[n], XmNheight, 118); n++;
    XtSetArg(args[n], XmNresizeHeight, FALSE ); n++;
    XtSetArg(args[n], XmNresizeWidth, FALSE); n++;
     XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
     XtSetArg(args[n], XmNnumColumns,1); n++;
     XtSetArg(args[n],XmNpacking,XmPACK_COLUMN);n++
;    Search_Fo9_Ra1 = XmCreateRadioBox(F_Search_Fo9_Ra1, "Radio_1",  args, n);
    XtManageChild(Search_Fo9_Ra1);

    n=0;
    XtSetArg(args[n], XmNx, 30); n++;
    XtSetArg(args[n], XmNy, 68); n++;
    tmpLabelString = XmStringCreateLtoR("Byte aligned", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 50); n++;
    XtSetArg(args[n], XmNheight, 7); n++;
    XtSetArg(args[n], XmNset, TRUE ); n++; 
    Search_byte = XmCreateToggleButton(Search_Fo9_Ra1, "Toggle_7", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_byte);

    n=0;
    XtSetArg(args[n], XmNx, 12); n++;
    XtSetArg(args[n], XmNy, 42); n++;
    tmpLabelString = XmStringCreateLtoR("Word aligned", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 21); n++;
    XtSetArg(args[n], XmNheight, 9); n++;
    Search_word = XmCreateToggleButton(Search_Fo9_Ra1, "Toggle_9", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_word);

    n=0;
    XtSetArg(args[n], XmNx, 17); n++;
    XtSetArg(args[n], XmNy, 12); n++;
    tmpLabelString = XmStringCreateLtoR("Bit aligned", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 50); n++;
    XtSetArg(args[n], XmNheight, 20); n++;
    XtSetArg(args[n], XmNalignment, 0 ); n++;
    Search_bit = XmCreateToggleButton(Search_Fo9_Ra1, "Toggle_4", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_bit);

    n=0;
    XtSetArg(args[n], XmNx, 234); n++;
    XtSetArg(args[n], XmNy, 49); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 97); n++;
    XtSetArg(args[n], XmNheight, 27); n++;
    tmpLabelString = XmStringCreateLtoR("Find", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Search_find = XmCreatePushButton(Search, "Pushbutton_4", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_find);

    n=0;
    XtSetArg(args[n], XmNx, 234); n++;
    XtSetArg(args[n], XmNy, 85); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 97); n++;
    XtSetArg(args[n], XmNheight, 27); n++;
    tmpLabelString = XmStringCreateLtoR("Done", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Search_Pu5 = XmCreatePushButton(Search, "Pushbutton_5", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_Pu5);

    n=0;
    XtSetArg(args[n], XmNx, 234); n++;
    XtSetArg(args[n], XmNy, 121); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 97); n++;
    XtSetArg(args[n], XmNheight, 27); n++;
    tmpLabelString = XmStringCreateLtoR("Next", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Search_Pu6 = XmCreatePushButton(Search, "Pushbutton_6", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_Pu6);

    n=0;
    XtSetArg(args[n], XmNx, 224); n++;
    XtSetArg(args[n], XmNy, 169); n++;
    tmpLabelString = XmStringCreateLtoR("keep search", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 103); n++;
    XtSetArg(args[n], XmNheight, 21); n++;
    Search_keep = XmCreateToggleButton(Search, "Toggle_14", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Search_keep);

    n=0;
     XtSetArg(args[n], XmNx, 175); n++;
    XtSetArg(args[n], XmNy, 133); n++;
    XtSetArg(args[n], XmNwidth, 38); n++;
    Search_Bpos = XmCreateTextField(Search, "Textfield_18", args, n);
    XtManageChild(Search_Bpos);

    /*  create graphics */

    /*  create additional attaches */

    /*  add all callbacks */
    XtAddCallback(Search_pattern, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(Search_pattern, XmNvalueChangedCallback,(XtCallbackProc)search_act_cb,(XtPointer)NULL );
    XtAddCallback(Search_mask, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(Search_mask, XmNvalueChangedCallback,(XtCallbackProc)search_act_cb,(XtPointer)(long int)NULL );
    XtAddCallback(Search_find, XmNactivateCallback,(XtCallbackProc)findit_cb,(XtPointer)NULL );
    XtAddCallback(Search_Pu5, XmNactivateCallback,(XtCallbackProc)done_search_cb,(XtPointer)NULL );
    XtAddCallback(Search_Pu6, XmNactivateCallback,(XtCallbackProc)find_next_cb,(XtPointer)NULL );
    XtAddCallback(Search_keep, XmNvalueChangedCallback,(XtCallbackProc)search_keep_cb,(XtPointer)NULL );
    XtAddCallback(Search_inverted, XmNvalueChangedCallback,(XtCallbackProc)inverted_cb,(XtPointer)NULL );
    XtAddCallback(Search_byte, XmNvalueChangedCallback,(XtCallbackProc)set_searchtyp_cb,(XtPointer)(long int)BYTE_ALIGN );
    XtAddCallback(Search_word, XmNvalueChangedCallback,(XtCallbackProc)set_searchtyp_cb,(XtPointer)(long int)WORD_ALIGN );
    XtAddCallback(Search_bit, XmNvalueChangedCallback,(XtCallbackProc)set_searchtyp_cb,(XtPointer)(long int)BIT_ALIGN );

/* Search FINIT-function */
	switch (SearchTyp & 0x0f){
        	case BYTE_ALIGN:
                	 XmToggleButtonSetState (Search_byte,TRUE,TRUE);
                         break;
                case  WORD_ALIGN:
                	 XmToggleButtonSetState (Search_word,TRUE,TRUE);
                         break;
                case  BIT_ALIGN:
                	 XmToggleButtonSetState (Search_bit,TRUE,TRUE);
                         XtUnmanageChild(Search_Bpos);
                         break;
	}
        if(SearchTyp & INVERTED)
        	XmToggleButtonSetState (Search_inverted,TRUE,FALSE); 
        if(Keep_Search)
        	XmToggleButtonSetState (Search_keep,TRUE,FALSE); 
                
    EAddQuickHelp (Search_help , Search_pattern , "Hexadecimal search pattern 8-digits");
    EAddQuickHelp (Search_help , Search_Bpos , "if Bit-aligned, displays the bit position");
    XtManageChild(Search);
    XtManageChild(MainShell);
    return Search;
}

/*************************************************************************** 
 * 
 * Funktionsname:  Configure_Create
 * 
 * 
 * Input:          Widget parent
 * 
 * Return:         Widget 
 * 
 * Dokumentation:  
 * 
 * 
 ***************************************************************************/

static Widget Configure_Create (Widget parent ){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget MainShell;
  Widget Configure;
Widget Configure_help;
Widget Configure_RC1;
Widget F_Configure_RC1;
Widget Configure_add;
Widget Configure_num;
Widget Configure_text;
Widget Configure_Pu7;
Widget Configure_size;
Widget Configure_La10;
Widget Configure_text_display;
Widget Configure_Pu8;
Widget Configure_keep;
    n = 0;
    XtSetArg(args[n], XmNwidth, 322); n++;
    XtSetArg(args[n], XmNheight, 230); n++;
    XtSetArg(args[n], XmNtitle, "Configure"); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    MainShell = (Widget)XmCreateDialogShell(XtParent(parent),"Form10_Dialog",args, n);

    n = 0;
     XtSetArg(args[n], XmNwidth, 322); n++;
    XtSetArg(args[n], XmNheight, 230); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
       XtSetArg(args[n], XmNwidth,322 ); n++;
       XtSetArg(args[n], XmNheight,230 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    Configure = GrCreateForm(MainShell, "Form10", args, n);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 198); n++;
    XtSetArg(args[n], XmNwidth, 322); n++;
    XtSetArg(args[n], XmNcursorPositionVisible,False);n++;
    XtSetArg(args[n], XmNtraversalOn,False);n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Configure_help = XmCreateTextField(Configure, "help", args, n);
    XtManageChild(Configure_help);

    n=0;
     XtSetArg(args[n], XmNx, 9); n++;
    XtSetArg(args[n], XmNy, 10); n++;
    XtSetArg(args[n], XmNwidth, 121); n++;
    XtSetArg(args[n], XmNheight, 102); n++;
    XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
    F_Configure_RC1= XmCreateFrame(Configure, "frame", args, n);
    tmpLabelString =  XmStringCreate("Scrollbars", XmSTRING_DEFAULT_CHARSET);
    XtVaCreateManagedWidget("Scrollbars",
    xmLabelGadgetClass, F_Configure_RC1,XmNchildType, XmFRAME_TITLE_CHILD,
    XmNlabelString, tmpLabelString,
    XmNchildVerticalAlignment, XmALIGNMENT_BASELINE_TOP,
    XmNchildHorizontalAlignment,  1,
    NULL);
    XmStringFree(tmpLabelString);
    XtManageChild(F_Configure_RC1);

    n=0;
     XtSetArg(args[n], XmNx, 9); n++;
    XtSetArg(args[n], XmNy, 10); n++;
    XtSetArg(args[n], XmNwidth, 121); n++;
    XtSetArg(args[n], XmNheight, 102); n++;
    XtSetArg(args[n], XmNnumColumns,1); n++;
     XtSetArg(args[n], XmNpacking, 0); n++;
    XtSetArg(args[n], XmNresizeHeight, FALSE ); n++;
    XtSetArg(args[n], XmNresizeWidth, FALSE); n++;
    XtSetArg(args[n], XmNadjustLast, FALSE); n++;
     XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
    Configure_RC1 = XmCreateRowColumn(F_Configure_RC1, "RowCol_1", args, n);
    XtManageChild(Configure_RC1);

    n=0;
    XtSetArg(args[n], XmNx, 8); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    tmpLabelString = XmStringCreateLtoR("Address", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 146); n++;
    XtSetArg(args[n], XmNheight, 22); n++;
    XtSetArg(args[n], XmNset, TRUE ); n++; 
    Configure_add = XmCreateToggleButton(Configure_RC1, "Toggle_10", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_add);

    n=0;
    XtSetArg(args[n], XmNx, 9); n++;
    XtSetArg(args[n], XmNy, 38); n++;
    tmpLabelString = XmStringCreateLtoR("Hex-Number", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 135); n++;
    XtSetArg(args[n], XmNheight, 25); n++;
    XtSetArg(args[n], XmNset, TRUE ); n++; 
    Configure_num = XmCreateToggleButton(Configure_RC1, "Toggle_11", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_num);

    n=0;
    XtSetArg(args[n], XmNx, 10); n++;
    XtSetArg(args[n], XmNy, 63); n++;
    tmpLabelString = XmStringCreateLtoR("Text", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 133); n++;
    XtSetArg(args[n], XmNheight, 26); n++;
    XtSetArg(args[n], XmNset, TRUE ); n++; 
    Configure_text = XmCreateToggleButton(Configure_RC1, "Toggle_12", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_text);

    n=0;
    XtSetArg(args[n], XmNx, 13); n++;
    XtSetArg(args[n], XmNy, 165); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 77); n++;
    XtSetArg(args[n], XmNheight, 26); n++;
    tmpLabelString = XmStringCreateLtoR("Done", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Configure_Pu7 = XmCreatePushButton(Configure, "Pushbutton_7", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_Pu7);

    n=0;
     XtSetArg(args[n], XmNx, 241); n++;
    XtSetArg(args[n], XmNy, 26); n++;
    XtSetArg(args[n], XmNwidth, 73); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    Configure_size = XmCreateTextField(Configure, "Textfield_17", args, n);
    XtManageChild(Configure_size);

    n=0;
     XtSetArg(args[n], XmNx, 140); n++;
    XtSetArg(args[n], XmNy, 29); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 100); n++;
    XtSetArg(args[n], XmNheight, 21); n++;
    XtSetArg(args[n], XmNalignment, 0 ); n++;
    tmpLabelString = XmStringCreateLtoR("Display size", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Configure_La10 = XmCreateLabel(Configure, "Label_10", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_La10);

    n=0;
    XtSetArg(args[n], XmNx, 140); n++;
    XtSetArg(args[n], XmNy, 68); n++;
    tmpLabelString = XmStringCreateLtoR("Text display", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 172); n++;
    XtSetArg(args[n], XmNheight, 27); n++;
    XtSetArg(args[n], XmNset, TRUE ); n++; 
    Configure_text_display = XmCreateToggleButton(Configure, "Toggle_13", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_text_display);

    n=0;
    XtSetArg(args[n], XmNx, 235); n++;
    XtSetArg(args[n], XmNy, 165); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 67); n++;
    XtSetArg(args[n], XmNheight, 26); n++;
    tmpLabelString = XmStringCreateLtoR("Save", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Configure_Pu8 = XmCreatePushButton(Configure, "Pushbutton_8", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_Pu8);

    n=0;
    XtSetArg(args[n], XmNx, 142); n++;
    XtSetArg(args[n], XmNy, 108); n++;
    tmpLabelString = XmStringCreateLtoR("keep search dialog", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 169); n++;
    XtSetArg(args[n], XmNheight, 24); n++;
    Configure_keep = XmCreateToggleButton(Configure, "Toggle_15", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Configure_keep);

    /*  create graphics */

    /*  create additional attaches */

    /*  add all callbacks */
    XtAddCallback(Configure_Pu7, XmNactivateCallback,(XtCallbackProc)configure_done_cb,(XtPointer)NULL );
    XtAddCallback(Configure_size, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(Configure_size, XmNactivateCallback,(XtCallbackProc)Configure_size_cb,(XtPointer)NULL );
    XtAddCallback(Configure_text_display, XmNvalueChangedCallback,(XtCallbackProc)set_text_display_cb,(XtPointer)NULL );
    XtAddCallback(Configure_Pu8, XmNactivateCallback,(XtCallbackProc)Configure_save_cb,(XtPointer)NULL );
    XtAddCallback(Configure_keep, XmNvalueChangedCallback,(XtCallbackProc)search_keep_cb,(XtPointer)(long int)NULL );
    XtAddCallback(Configure_add, XmNvalueChangedCallback,(XtCallbackProc)configure_scrollbar_cb,(XtPointer)(long int)1 );
    XtAddCallback(Configure_num, XmNvalueChangedCallback,(XtCallbackProc)configure_scrollbar_cb,(XtPointer)(long int)2 );
    XtAddCallback(Configure_text, XmNvalueChangedCallback,(XtCallbackProc)configure_scrollbar_cb,(XtPointer)(long int)3 );

/* Configure FINIT-function */

	if(!scrollnum)
 		XmToggleButtonSetState (Configure_num,FALSE,FALSE);
	if(!scrolladd)
 		XmToggleButtonSetState (Configure_add,FALSE,FALSE);
	if(!scrolltext)
 		XmToggleButtonSetState (Configure_text,FALSE,FALSE);

	MTextSetHex(Configure_size,Block_Size );
        
	if(!Display_Text)
 		XmToggleButtonSetState (Configure_text_display,FALSE,FALSE);
	if(!Display_Text){
		XtVaSetValues(Toplevel,XmNwidth, 997 -350,NULL);                
		XtUnmanageChild(Hex_Text);
	}
        if(Keep_Search )
        	XmToggleButtonSetState (Configure_keep,TRUE,FALSE); 
                      
    EAddQuickHelp (Configure_help , Configure_size , "Address range to display as Block. Must be Hex");
    XtManageChild(Configure);
    XtManageChild(MainShell);
    return Configure;
}

/*************************************************************************** 
 * 
 * Funktionsname:  Extract_Create
 * 
 * 
 * Input:          Widget parent
 * 
 * Return:         Widget 
 * 
 * Dokumentation:  
 * 
 * 
 ***************************************************************************/

static Widget Extract_Create (Widget parent ){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget MainShell;
  Widget Extract;
Widget Extract_Tf20;
Widget Extract_La11;
Widget Extract_La12;
Widget Extract_La13;
Widget Extract_Pu9;
Widget Extract_Pu10;
    n = 0;
    XtSetArg(args[n], XmNwidth, 384); n++;
    XtSetArg(args[n], XmNheight, 144); n++;
    XtSetArg(args[n], XmNtitle, "Extract part of file"); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    MainShell = (Widget)XmCreateDialogShell(XtParent(parent),"Form12_Dialog",args, n);

    n = 0;
     XtSetArg(args[n], XmNwidth, 384); n++;
    XtSetArg(args[n], XmNheight, 144); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, FALSE); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
       XtSetArg(args[n], XmNwidth,384 ); n++;
       XtSetArg(args[n], XmNheight,144 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    Extract = GrCreateForm(MainShell, "Form12", args, n);

    n=0;
     XtSetArg(args[n], XmNx, 107); n++;
    XtSetArg(args[n], XmNy, 7); n++;
    XtSetArg(args[n], XmNwidth, 121); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    Extract_from = XmCreateTextField(Extract, "Textfield_19", args, n);
    XtManageChild(Extract_from);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 120); n++;
    XtSetArg(args[n], XmNwidth, 384); n++;
    XtSetArg(args[n], XmNcursorPositionVisible,False);n++;
    XtSetArg(args[n], XmNtraversalOn,False);n++;
    XtSetArg(args[n], XmNeditable, FALSE ); n++;
    Extract_Tf20 = XmCreateTextField(Extract, "help", args, n);
    XtManageChild(Extract_Tf20);

    n=0;
     XtSetArg(args[n], XmNx, 107); n++;
    XtSetArg(args[n], XmNy, 44); n++;
    XtSetArg(args[n], XmNwidth, 121); n++;
    XtSetArg(args[n], XmNmaxLength,8 ); n++;
    Extract_to = XmCreateTextField(Extract, "Textfield_21", args, n);
    XtManageChild(Extract_to);

    n=0;
#ifndef LESSTIFF
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
     XtSetArg(args[n], XmNx, 0); n++;
    XtSetArg(args[n], XmNy, 89); n++;
    XtSetArg(args[n], XmNwidth, 384); n++;
    Extract_path = XmCreateTextField(Extract, "Textfield_22", args, n);
    XtManageChild(Extract_path);

    n=0;
     XtSetArg(args[n], XmNx, 7); n++;
    XtSetArg(args[n], XmNy, 9); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 90); n++;
    XtSetArg(args[n], XmNheight, 21); n++;
    tmpLabelString = XmStringCreateLtoR("first address", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Extract_La11 = XmCreateLabel(Extract, "Label_11", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Extract_La11);

    n=0;
     XtSetArg(args[n], XmNx, 4); n++;
    XtSetArg(args[n], XmNy, 51); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 96); n++;
    XtSetArg(args[n], XmNheight, 18); n++;
    tmpLabelString = XmStringCreateLtoR("last address", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Extract_La12 = XmCreateLabel(Extract, "Label_12", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Extract_La12);

    n=0;
     XtSetArg(args[n], XmNx, 112); n++;
    XtSetArg(args[n], XmNy, 75); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 113); n++;
    XtSetArg(args[n], XmNheight, 12); n++;
    tmpLabelString = XmStringCreateLtoR("extraction path", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Extract_La13 = XmCreateLabel(Extract, "Label_13", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Extract_La13);

    n=0;
    XtSetArg(args[n], XmNx, 298); n++;
    XtSetArg(args[n], XmNy, 4); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 82); n++;
    XtSetArg(args[n], XmNheight, 29); n++;
    tmpLabelString = XmStringCreateLtoR("EXTRACT", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Extract_Pu9 = XmCreatePushButton(Extract, "Pushbutton_9", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Extract_Pu9);

    n=0;
    XtSetArg(args[n], XmNx, 297); n++;
    XtSetArg(args[n], XmNy, 56); n++;
    XtSetArg(args[n], XmNrecomputeSize, FALSE ); n++;
    XtSetArg(args[n], XmNwidth, 82); n++;
    XtSetArg(args[n], XmNheight, 29); n++;
    tmpLabelString = XmStringCreateLtoR("Cancel", XmFONTLIST_DEFAULT_TAG);
    XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
    Extract_Pu10 = XmCreatePushButton(Extract, "Pushbutton_10", args, n);
    XmStringFree(tmpLabelString);
    XtManageChild(Extract_Pu10);

    /*  create graphics */

    /*  create additional attaches */

    /*  add all callbacks */
    XtAddCallback(Extract_from, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(Extract_to, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnHexCb, NULL);
    XtAddCallback(Extract_path, XmNmodifyVerifyCallback, (XtCallbackProc) ModifyVerifyCheckOnLetterCb, NULL);
    XtAddCallback(Extract_Pu9, XmNactivateCallback,(XtCallbackProc)do_extract_cb,(XtPointer)NULL );
    XtAddCallback(Extract_Pu10, XmNactivateCallback,(XtCallbackProc)extract_cancel_cb,(XtPointer)NULL );

/* Extract FINIT-function */
	MTextSetHex(Extract_from, Startaddress);
        MTextSetHex(Extract_to , Endaddress);
        MTextSetString (Extract_path, "Hex_extract");
        
    EAddQuickHelp (Extract_Tf20 , Extract_from , "Startind address of extraction");
    EAddQuickHelp (Extract_Tf20 , Extract_to , "terminating address of extraction");
    EAddQuickHelp (Extract_Tf20 , Extract_path , "Filename of extraction");
    XtManageChild(Extract);
    XtManageChild(MainShell);
    return Extract;
}

/*************************************************************************** 
 * 
 * Funktionsname:  About_Create
 * 
 * 
 * Input:          Widget parent
 * 
 * Return:         Widget 
 * 
 * Dokumentation:  
 * 
 * 
 ***************************************************************************/

static Widget About_Create (Widget parent ){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget MainShell;
  Widget About;
    n = 0;
    XtSetArg(args[n], XmNwidth, 248); n++;
    XtSetArg(args[n], XmNheight, 35); n++;
    XtSetArg(args[n], XmNtitle, "About"); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    MainShell = (Widget)XmCreateDialogShell(XtParent(parent),"Form13_Dialog",args, n);

    n = 0;
     XtSetArg(args[n], XmNwidth, 248); n++;
    XtSetArg(args[n], XmNheight, 35); n++;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
    XtSetArg(args[n], XmNnoResize, FALSE); n++;
       n=0;
       XtSetArg(args[n], XmNnoResize, FALSE); n++;
    XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
       XtSetArg(args[n], XmNwidth,248 ); n++;
       XtSetArg(args[n], XmNheight,35 ); n++;
       XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
       XtSetArg(args[n], XmNresizable,FALSE);n++;
    About = GrCreateForm(MainShell, "Form13", args, n);

    n=0;
     XtSetArg(args[n], XmNx, 1); n++;
    XtSetArg(args[n], XmNy, 0); n++;
    XtSetArg(args[n], XmNwidth, 246); n++;
    About_Tf24 = XmCreateTextField(About, "Textfield_24", args, n);
    XtManageChild(About_Tf24);

    /*  create graphics */

    /*  create additional attaches */

    /*  add all callbacks */
    XtAddCallback(About_Tf24, XmNactivateCallback,(XtCallbackProc)Version_cb,(XtPointer)NULL );

/* About FINIT-function */
{
    char version[20]="Release:";
    strcat (version,VERSION);    
    MTextSetString (About_Tf24, version);
}
    XtManageChild(About);
    XtManageChild(MainShell);
    return About;
}

/*    CALLBACKS */

/***************************************************************************
 ***************************************************************************

  Callback name:	selectFile_cb
  
  Input:		Widget parent , XtPointer data , XmPushButtonCallbackStruct * cbs

  Documentation:	Just calls the fiole-selector box, adding a callback to it


  History:		Wed Nov 26 15:18:58 2008



 ***************************************************************************
 ***************************************************************************/
static void selectFile_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

	CreatefilteredFBox (parent, "*" ,get_Hex_file, "File to dump");
}

/***************************************************************************
 ***************************************************************************

  Callback name:	quit_cb
  
  Input:		Widget parent , XtPointer data , XmPushButtonCallbackStruct * cbs

  Documentation:	Terminating  Hex-Dump, cleaning up everything


  History:		Sat Nov 29 16:40:38 2008



 ***************************************************************************
 ***************************************************************************/
static void quit_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

/* prior to closing, we should decide, if the mapped file is to be rewritten from num-Widget */

	MCloseDialog (parent);
}
static void extract_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	Extract_Create (parent); 
/* dialog is using XtParent(parent)   check if correct */
}
static void about_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
    About_Create (parent); 
/* dialog is using XtParent(parent)   check if correct */
}

/***************************************************************************
 ***************************************************************************

  Callback name:	redisplay_cb
  
  Input:		Widget parent , int data , XmPushButtonCallbackStruct * cbs

  Documentation:	depending on data increments or decrements
                        Startaddress by Bolcksize
                        call display of new area


  History:		Mon Dec  1 09:36:30 2008



 ***************************************************************************
 ***************************************************************************/
static void redisplay_cb (Widget parent, int data , XmPushButtonCallbackStruct * cbs ){


	if(data == 1){
        	Startaddress += Block_Size;
                
        }else if (data == -1){
        	Startaddress -= Block_Size;
                if(Startaddress < 0)
                	Startaddress = 0;
        }
        Endaddress    = Startaddress + Block_Size;
        XmTextClearSelection(Hex_Number,  XtLastTimestampProcessed(XtDisplay(Hex_Number)));
        MTextSetString (Hex_input, "");
        MTextSetString (Hex_TE_input, "");
        MTextSetString (Hex_Maddress, "");
        MTextSetString (Hex_control, "");
        Display_it (  );
}
static void get_got_address_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	address_Create (parent); 
/* dialog is using XtParent(parent)   check if correct */
}
static void search_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
 Position  y,x;
 Dimension h,w;
  
  	XtVaGetValues(Toplevel,XmNx , &x ,XmNy , &y,XmNheight , &h,XmNwidth , &w,NULL);
	Search_Create (Hex, 0,h); 
/* dialog is using XtParent(parent)   check if correct */
}
static void setlogfile_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

	CreatefilteredFBox (parent, "*.log" ,open_logfile, "Select Logfile");
}
static void printactual_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	printout ( Startaddress , Endaddress );		        
}
static void printall_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	printout ( 0 , Map_Size );		        

}
static void get_printfile_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	CreatefilteredFBox (parent, "*.ps" ,get_printfile, "Select Printfile");
}
static void configure_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	Configure_Create (parent); 
/* dialog is using XtParent(parent)   check if correct */
}

/***************************************************************************
 ***************************************************************************

  Callback name:	Toggle_edit_cb
  
  Input:		Widget parent , XtPointer data , XmToggleButtonCallbackStruct * cbs

  Documentation:	toggling will switch the  File between read and write
                        the input field will be switched to editable and back
                        the colour will indicate the sitiuation
			when switching, the change in mode is done via a remap
			switching to editable will copy input file to backup,
                        if first switch.
  History:		Thu Dec 11 17:28:58 2008



 ***************************************************************************
 ***************************************************************************/
static void Toggle_edit_cb (Widget parent, XtPointer data , XmToggleButtonCallbackStruct * cbs ){
  static char dumpp[256]="";
  char syst[256];
	if(cbs->set && dumpPath){
        	if(strcmp(dumpPath , dumpp)){
                	strcpy(dumpp,dumpPath);
                        sprintf(syst,"cp %s %s.hex \n",dumpPath,dumpPath);
                        system(syst);
                }
        	EDITABLE = TRUE;
		XtVaSetValues(Hex_input,XmNeditable,TRUE
                ,XmNbackground,MGetPixel("LightCyan", parent),NULL);
		XtVaSetValues(Hex_TE_input,XmNeditable,TRUE
                ,XmNbackground,MGetPixel("LightCyan", parent),NULL);
 		XtVaSetValues(parent,XmNbackground,MGetPixel("LightCyan", parent),NULL);
                remap();	/* remap the file with read/write */
               
        }else{
        	EDITABLE = FALSE;
		XtVaSetValues(Hex_input,XmNeditable,FALSE
                ,XmNbackground,MGetPixel("linen", parent),NULL);
		XtVaSetValues(Hex_TE_input,XmNeditable,FALSE
                ,XmNbackground,MGetPixel("linen", parent),NULL);
 		XtVaSetValues(parent,XmNbackground,MGetPixel("linen", parent),NULL);
                remap();	/* remap the file with read only */
        }
}

/***************************************************************************
 ***************************************************************************

  Callback name:	change_now_cb
  
  Input:		Widget parent , XtPointer data , XmTextVerifyCallbackStruct * cbs

  Documentation:	Accept the contents of input field and do modification


  History:		Thu Dec 11 17:05:17 2008



 ***************************************************************************
 ***************************************************************************/
static void change_now_cb (Widget parent, XtPointer data , XmTextVerifyCallbackStruct * cbs ){
  char *text = MTextGetString (parent);
  	MTextSetString (Hex_error, "");
        
	rewrite ( text );
        XtFree(text);
/* moditication done, clear down all selection */
	MTextSetString (parent, "");
        Reset_mod();
/* redisplay all */        
        Display_it (  );
}

/***************************************************************************
 ***************************************************************************

  Callback name:	addr_increm_cb
  
  Input:		Widget parent , int data , XmPushButtonCallbackStruct * cbs

  Documentation:	checking the new address for legality
                        then call display_address to position selection at this.


  History:		Tue Dec 16 12:21:52 2008



 ***************************************************************************
 ***************************************************************************/
static void addr_increm_cb (Widget parent, int data , XmPushButtonCallbackStruct * cbs ){
 int address = Maddr + data;
 XmTextPosition start,end;
 
 	XmTextGetSelectionPosition(Hex_Number,&start,&end);
	if(address < 0 || address > Map_Size || (!start && !end))        	
                return;
        
	display_address (address , 0);
	return;
}

/***************************************************************************
 ***************************************************************************

  Callback name:    change_now_TE_cb
  
  Input:            Widget parent , XtPointer data , XmTextVerifyCallbackStruct * cbs

  Documentation:    callback for a change in the Text_input field. Te binarry representation is copied to
  the Hex-input field, and the callback of the hex-input field is called.
                    
                    
  History:          Tue May 24 06:59:32 2016



 ***************************************************************************
 ***************************************************************************/
static void change_now_TE_cb (Widget parent, XtPointer data , XmTextVerifyCallbackStruct * cbs ){
  char *text = MTextGetString (parent);
  unsigned char *hex ;
  int ndigits;
  unsigned char replace[12];
    
  	MTextSetString (Hex_error, "");
        memcpy(&Map[Maddr],text,4);
        sprintf(replace,"%x%x%x%x",text[0] ,text[1] ,text[2] ,text[3]); 
 
        MTextSetString (Hex_input ,replace);
        XtFree(text);
  	MTextSetString (Hex_error, "");
        
        /* moditication done, clear down all selection */
	MTextSetString (parent, "");
       /*  Reset_mod(); */
        /* use the hex_input callback to rewrite all * */        
        change_now_cb (Hex_input, NULL ,  cbs );
        
        /* moditication done, clear down all selection */

        XmTextClearSelection(Hex_Text,  XtLastTimestampProcessed(XtDisplay(Hex_Number)));
        TXstart = TXend = 0;
        TXnpos=Maddr=0;
}
static void errorquit_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	MCloseDialog (parent);
}

/***************************************************************************
 ***************************************************************************

  Callback name:	goto_address_cb
  
  Input:		Widget parent , XtPointer data , XmTextVerifyCallbackStruct * cbs

  Documentation:	take the given hex value and dselect the given
                        address in display (redisplaying, if other block)
                        rejects input if outside of file


  History:		Sun Dec 14 10:19:06 2008



 ***************************************************************************
 ***************************************************************************/
static void goto_address_cb (Widget parent, XtPointer data , XmTextVerifyCallbackStruct * cbs ){
  int address = MTextGetHex(parent);
	if(address < 0 || address > Map_Size){
        	cbs->doit = FALSE ;
                return;
        }
        display_address (address , 0);
        MCloseDialog (parent); 
        return;      
}
static void search_act_cb (Widget parent, XtPointer data , XmTextVerifyCallbackStruct * cbs ){
        XtSetSensitive(Search_find,TRUE);		 /* use next to get next hit */

}
static void inverted_cb (Widget parent, XtPointer data , XmToggleButtonCallbackStruct * cbs ){
	if(cbs->set)
        	SearchTyp |= INVERTED;
        else
        	SearchTyp &= !INVERTED;
}
static void set_searchtyp_cb (Widget parent, int data , XmToggleButtonCallbackStruct * cbs ){

	if(cbs->set){
        	SearchTyp &= 0xf0;
                SearchTyp |= data;
                if((data & BIT_ALIGN) == BIT_ALIGN)
                	XtManageChild (Search_Bpos);
                else
                	XtUnmanageChild (Search_Bpos);        
        }
               
}

/***************************************************************************
 ***************************************************************************

  Callback name:	findit_cb
  
  Input:		Widget parent , XtPointer data , XmPushButtonCallbackStruct * cbs

  Documentation:	gets the strings from search field and mask field
  			as hex pattern.
                        adjusts the mask to the length of the search pattern,
                        adding zeroes in front (same with search string)
                        then converts the strings into series of numeric bytes
                        as search should be on binary data.
                        The conversion is done manually, as scanf refuses to do it?!
                        Finally, it should call the seach engine.


  History:		Tue Dec 16 18:01:00 2008



 ***************************************************************************
 ***************************************************************************/
static void findit_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
   
   int l ;
   
   char *strh=MTextGetString (Search_pattern);
   char *strm=MTextGetString (Search_mask);
   char string[9]="0",mstr[9]="0";
   unsigned char search[4],mask[4];
   
   
   
   	l=strlen(strh);
   	if(l & 1){
        	strcat(string,strh);
                strncat(mstr,strm,l);
                l++;
   	}else{
   		strcpy(string,strh);
                strncpy(mstr,strm,l);
        }        
	XtFree(strh);
        XtFree(strm);
        
        memset(mask,0,sizeof(mask));
        reconvert ( string , search , l);
        reconvert ( mstr , mask , l);
        if(Log)
        	fprintf(Log,"SEARCH for: Pattern: %s  Mask: %s \n",string,mstr);
                
        XtSetSensitive(parent,FALSE);		 /* use next to get next hit */
        MTextSetString (Hex_control, "");
        MTextSetString (Hex_input, "");
        MTextSetString (Hex_Maddress, "");

        if(search_pattern( search , mask , l/2, 0 ) 
        	&& !Keep_Search)  /* not found, so close search */
        	done_search_cb (parent, data , cbs );
}
static void done_search_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	
        MCloseDialog (parent);
}
static void find_next_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

	if( search_pattern ( NULL ,NULL , 0 , 1) && !Keep_Search)
        	MCloseDialog (parent);
}
static void search_keep_cb (Widget parent, XtPointer data , XmToggleButtonCallbackStruct * cbs ){
	if(cbs->set)
        	Keep_Search = TRUE;
        else
        	Keep_Search = FALSE;
}

/***************************************************************************
 ***************************************************************************

  Callback name:	set_scrollbar
  
  Input:		Widget parent , int data , XmToggleButtonCallbackStruct * cbs

  Documentation:	Activate / deactivate scollbar of Display
                        data = 1	Address scrollbar
                        data = 2        Hexnumber scrollbar
                        data = 3        text   scrollbar
                        There must be at least one scrollbar active

  History:		Fri Dec 19 10:48:24 2008



 ***************************************************************************
 ***************************************************************************/
static void configure_scrollbar_cb (Widget parent, int data , XmToggleButtonCallbackStruct * cbs ){

	switch (data){
        	case 1:
                	if(!cbs->set){
                        	if(!scrollnum && ! scrolltext){
                                	cbs->set = FALSE;
                                        return;
                		}
                                XtUnmanageChild(ScrollAdd);
                        }else{
                                XtManageChild(ScrollAdd);
                        }
                        scrolladd =  cbs->set;
                        break;       
        	case 2:
                	if(!cbs->set){
                        	if(!scrolladd && ! scrolltext){
                                	cbs->set = FALSE;
                                        return;
                		}
                                XtUnmanageChild(ScrollNum);
                        }else{
                                XtManageChild(ScrollNum);
                        }
                        scrollnum =  cbs->set;       
                        break;       
        	case 3:
                	if(!cbs->set){
                        	if(!scrolladd && ! scrollnum){
                                	cbs->set = FALSE;
                                        return;
                		}
                                XtUnmanageChild(ScrollText);
                        }else{
                                XtManageChild(ScrollText);
                        }
                        scrolltext =  cbs->set;       
                        break;       
	}
}
static void configure_done_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	MCloseDialog (parent);
}

/***************************************************************************
 ***************************************************************************

  Callback name:	Configure_size_cb
  
  Input:		Widget parent , XtPointer data , XmTextVerifyCallbackStruct * cbs

  Documentation:	The given Hexnumber is truncated to a base of 8 words
                        New addresses are calculated and redisplayed


  History:		Fri Dec 19 14:04:18 2008



 ***************************************************************************
 ***************************************************************************/
static void Configure_size_cb (Widget parent, XtPointer data , XmTextVerifyCallbackStruct * cbs ){
  unsigned int size = MTextGetHex(parent) ;

	size &= 0xffffffe0;
        Block_Size = size;
        Endaddress = Startaddress + Block_Size;
        if(DumpFd > 0)
        	Display_it ( );
}
static void set_text_display_cb (Widget parent, XtPointer data , XmToggleButtonCallbackStruct * cbs ){

	if(cbs->set){
        	XtVaSetValues(Toplevel,XmNwidth, 997,NULL);
		XtManageChild(Hex_Text);
		XtVaSetValues(Hex,XmNwidth, 997 ,NULL);                
        }else{
		XtVaSetValues(Toplevel,XmNwidth, 997 -350,NULL);                
		XtVaSetValues(Hex,XmNwidth, 997 -350,NULL);                
		XtUnmanageChild(Hex_Text);
        }
        Display_Text = cbs->set;
}

/***************************************************************************
 ***************************************************************************

  Callback name:	Configure_save_cb
  
  Input:		Widget parent , XtPointer data , XmPushButtonCallbackStruct * cbs

  Documentation:	writes the actual configuration to file
                        ( "~/.rcHexDump" )
                        witing all, the reading should reflect the sequence


  History:		Fri Dec 19 14:02:42 2008



 ***************************************************************************
 ***************************************************************************/
static void Configure_save_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
  FILE *sv;
  char  rcfile[256];
  
  	strcpy(rcfile,getenv("HOME"));
        strcat(rcfile,"/.HexDumprc");
  	sv = fopen(rcfile,"w");
        
        fprintf(sv,"ScrollNum:%d\n",scrollnum);
        fprintf(sv,"ScrollAdd:%d\n",scrolladd);
        fprintf(sv,"ScrollText:%d\n",scrolltext);
        fprintf(sv,"Block_Size:%d\n",Block_Size);
        fprintf(sv,"Hex_Text:%d\n",Display_Text);
        fprintf(sv,"Keep_Search:%d\n",Keep_Search);
        fprintf(sv,"Search_Typ:%d\n",SearchTyp);
        fprintf(sv,"END\n");
  	fclose(sv);
        MCloseDialog (parent);
}

/***************************************************************************
 ***************************************************************************

  Callback name:    do_extract_cb
  
  Input:            Widget parent , XtPointer data , XmPushButtonCallbackStruct * cbs

  Documentation:    
                    
                    
  History:          Tue May 24 07:02:07 2016



 ***************************************************************************
 ***************************************************************************/
static void do_extract_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

  unsigned int start = MTextGetHex(Extract_from);
  unsigned int end   = MTextGetHex(Extract_to);
  char *path  = MTextGetString (Extract_path);	
  FILE *extr;
  
	if( !path || !path[0])
        	return;
        if(start < 0 )
        	start = 0;
        if(end > Map_Size )
        	end = Map_Size ;               
        if(!(extr=fopen(path,"w")))
        	return;
                
        fwrite(&Map[start] , 1 ,  end - start, extr);
        fclose (extr);
        XtFree( path ); 
        MCloseDialog (parent);            
}
static void extract_cancel_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	MCloseDialog (parent);
}
static void Version_cb (Widget parent, XtPointer data , XmTextVerifyCallbackStruct * cbs ){
    MTextSetString (About_Tf24, VERSION);
    
}

/*    EVENT HANDLERS */

/***************************************************************************
 ***************************************************************************

  Functionname:		selection_ev
  
  Input:		Widget parent, XtPointer clientData, XEvent *event, Boolean *continueToDispatch
  Output:   	    	
  Return:		 void

  Documentation:	Button release handler
  			calls select to get the positions and address
                        checks for any selection, gives waring, if editable
                        and no range of selection
                        clears the fields of address, control and input


  History:		Tue Dec 16 12:31:03 2008



 ***************************************************************************
 ***************************************************************************/
static void selection_ev (Widget parent, int clientData, XEvent *event, Boolean *continueToDispatch) {

	if(!selected ( clientData)){
        	if(EDITABLE)
        		MTextSetString (Hex_error, "nothing selected");
                MTextSetString (Hex_Maddress,"");
                MTextSetString (Hex_input ,"");
                MTextSetString (Hex_TE_input ,"");
                MTextSetString (Hex_control ,"");
        }
        	
}

/*    FUNCTIONS */

/***************************************************************************
 ***************************************************************************

  Functionname:		get_Hex_file
  
  Input:		char *path
  
  Return:		 void

  Documentation:	If already file selected, closes it.
                        saves the path  to global variable, gets the size
                        and maps the file into memory.
                        finally calls Display_it to get the contents displayed.
			resets to first block. resets editable to NOT edit

  History:		Wed Nov 26 15:23:01 2008



 ***************************************************************************
 ***************************************************************************/
static void get_Hex_file ( char *path ) {
  struct stat buf;
  char  title[200]="Hex Display  ";
  char str[200]="cannot read ";
  
  	XmToggleButtonSetState (Hex_edit,FALSE,TRUE);
  	Startaddress=0;
        Endaddress= Block_Size;
  
	if(dumpPath)
		free(dumpPath);
	if(DumpFd >= 0)
		close( DumpFd );     
	dumpPath = strdup (path);
	DumpFd = open(dumpPath, O_RDONLY);
        if(DumpFd < 0 ){
        	strcat(str,dumpPath);
                Error_Create (Hex_control, str); 
                return;
        }
/* dialog is using XtParent(parent)   check if correct */
	fstat(DumpFd, &buf);
	Map_Size = buf.st_size;
	Map = (unsigned char *)mmap(NULL,buf.st_size,PROT_READ,MAP_SHARED,DumpFd,0);
	strcat(title,dumpPath);
        XtVaSetValues(Toplevel, XmNtitle,title,NULL);
        Reset_mod ( );
	Display_it (  );
        XtSetSensitive(Hex_Searching,TRUE);
}

/***************************************************************************
 ***************************************************************************

  Functionname:		Display_it
  
  
  Return:		 void

  Documentation:	First clears the three scrolled rext widgets.
                        Then looping thru the mapped file writes Address
                        Hex-Numbers of a 32 bytes line, and the corresponding text


  History:		Wed Nov 26 15:20:59 2008



 ***************************************************************************
 ***************************************************************************/
void Display_it ( void ) {
   int address = Startaddress;
   int lim;
   
   	Dont = TRUE;    /* inhibit synchronization of scrolled areas during update */
   	if(address > 0)
        	XtSetSensitive(Hex_decrem,TRUE);
        else
                XtSetSensitive(Hex_decrem,FALSE);
	XmTextSetString(Hex_Number,"");
	XmTextSetString(Address,"");
	XmTextSetString(Hex_Text,"");

   	lim = (Endaddress < Map_Size) ? Endaddress  :  Map_Size ;
	while(address < lim){
		Address_line ( address );
		Hex_line ( address );
		text_line ( address );
		address += 32; 
	}
   	Dont = FALSE;    /* Reallow synchronization */ 
        if(address < Map_Size -32 )
        	XtSetSensitive(Hex_increm,TRUE);
        else
                XtSetSensitive(Hex_increm,FALSE);
	if(Hex_number)
        	XtFree(Hex_number);
        Hex_number = XmTextGetString(Hex_Number); 
        Hex_text= XmTextGetString(Hex_Text ); 
        XmTextSetTopCharacter(Hex_Text,0);
           
}

/***************************************************************************
 ***************************************************************************

  Functionname:		Address_line
  
  Input:		int address
  
  Return:		 void

  Documentation:	write the given address to the Address text-widget as
                        new line.


  History:		Wed Nov 26 15:19:41 2008



 ***************************************************************************
 ***************************************************************************/
static void Address_line ( int address ) {
   char line[12];
   
   sprintf(line,"%8.8X\n",address);
   XmTextInsert(Address,XmTextGetLastPosition(Address),line);
   
}

/***************************************************************************
 ***************************************************************************

  Functionname:		Hex_line
  
  Input:		int address
  
  Return:		 void

  Documentation:	one line, i.e. 32 bytes are written in groups of 4
                        as Hexnumbers. To show endianess, the bytes are written
                        as bytes!!! The Hex-Conversion is done via internal table
                        to gain speed.
                        finally the line is added to the corresponding scrolled
                        Text-widget printable bytes togethe with word delimiter
                        and some special characters, indicating control bytes.
                        The Format of the written text must be reconvertable,
                        therefore: 8-Digits + space is one word address,
                        8 items + "\n" is a line
                        last line may be incomplete

  History:		Wed Nov 26 15:25:01 2008



 ***************************************************************************
 ***************************************************************************/
static void Hex_line ( int address ) {
  int k;
  char line[76];
  static char D[16]="0123456789ABCDEF";
  int lim =  (Map_Size > (address + 32)) ? address + 32 : Map_Size;

	for(k=0;address < lim;address++){
		line[k++]=D[Map[address]>>4];
		line[k++]=D[Map[address] & 0x0f];
		if((address & 0x03) == 3)
			line[k++]=' ';
	}        
	line[k-1] = '\n';   	
	line[k++] = 0;   	
	XmTextInsert(Hex_Number,XmTextGetLastPosition(Hex_Number),line);

}

/***************************************************************************
 ***************************************************************************

  Functionname:		text_line
  
  Input:		int address
  
  Return:		 void

  Documentation:	displays the next 32 byres from address to the text widget
                        nonprintable and control characters are replaced by a 
                        special character.


  History:		Wed Nov 26 15:30:40 2008



 ***************************************************************************
 ***************************************************************************/
static void text_line ( int address ) {
  int k;
  char line[76];
  int lim =  (Map_Size > (address + 32)) ? address + 32 : Map_Size;
  
	for(k=0;address < lim;address++){
		if(isprint(Map[address])/*  && ! iscntrl(Map[address]) */)
			line[k++]=Map[address];
                else if(iscntrl(Map[address]))
                        line[k++]= ''; /* use   as space of control */    
		else
			line[k++]='.';
		if((address & 0x03) == 3)
			line[k++]='';  /* add word delimter */
	}
	if(line[k-1] == '')line[k-1]='\n';         	
	line[k++] = 0;   	
	XmTextInsert(Hex_Text,XmTextGetLastPosition(Hex_Text),line);
}

/***************************************************************************
 ***************************************************************************

  Functionname:		Move_cb
  
  Input:		Widget parent
                        XtPointer data   shows which parent (addrss, num, text)
                        XmScrollBarCallbackStruct * cbs 
  
  Return:		 void

  Documentation:	general callback for any move of scrollbar, via drag
                        or arrows.
                        It reflects the move to the two other Text-Widgets.
                        


  History:		Wed Nov 26 15:27:37 2008



 ***************************************************************************
 ***************************************************************************/
static void Move_cb ( Widget parent, XtPointer data , XmScrollBarCallbackStruct * cbs  ) {
 
 int val,siz,incr,pag;
 int max1;

	if(Dont)
		return;


XtVaGetValues(parent,XmNmaximum, &max1,NULL);


XtVaSetValues(ScrollAdd,XmNmaximum, max1 ,NULL);
XtVaSetValues(ScrollNum,XmNmaximum, max1,NULL);
XtVaSetValues(ScrollText,XmNmaximum, max1,NULL);


	XmScrollBarGetValues (parent, &val, &siz,
		&incr, &pag);
/*
 * if(parent == ScrollAdd){
 * if(val+siz >= max1)
 *   printf("UNTEN \n");
 * else if(val == 0)
 * printf("OBEN\n");
 * 
 * 
 *  printf("Max: %d Val: %d size: %d \n",max1,val,siz);
 *  }
 */
	if(ScrollNum != parent)      
		XmScrollBarSetValues (ScrollNum, val, siz,
			incr, pag,TRUE);
	if(ScrollText != parent )      
		XmScrollBarSetValues (ScrollText, val, siz,
			incr, pag,TRUE);
	if(ScrollAdd != parent )      
		XmScrollBarSetValues (ScrollAdd, val, siz,
			incr, pag,TRUE);
}

/***************************************************************************
 ***************************************************************************

  Functionname:		main
  
  Input:		int argc; char *argv[]
  
  Return:		int

  Documentation:	This main was originally created by EasyMotif, but we need
                        the toplevel Widget for further access, so it was copies as 
                        a function and modified.


  History:		Sun Dec  7 15:58:29 2008



 ***************************************************************************
 ***************************************************************************/
int main(int argc,char **argv){
  XtAppContext app_context;
  Widget  MainDialog;
  Arg args[40];
  Cardinal n;
  /* INITIALIZE THE TOPLEVEL */

	Configure_get ( );

	n=0;
	XtSetArg(args[n], XmNtitle, "Hex Display"); n++;
  /* INITIALIZE THE TOPLEVEL */

	Toplevel = XtAppInitialize(&app_context, "HEx", NULL, 0, &argc, argv, fallback_resources, args, n);

	  /* CREATE THE MAINDIALOG */

	MainDialog = Hex_Create(Toplevel);
  /* MANAGE AND REALIZE THE SHELL WIDGETS */

	XtManageChild(MainDialog);
	XtRealizeWidget(Toplevel);

  /* START THE MESSAGE-QUEUE */
	XtAppMainLoop(app_context);
	 Mterminate_thread( &app_context);
	return 0;
}

/***************************************************************************
 ***************************************************************************

  Functionname:		remap
  
  Input:		
  Output:   	    	
  
  Return:		 void

  Documentation:	depending on the state of toggle mode, reopens
                        the file withe read or write. if not writable
                        adjusts the toggle button and raises an Error.


  History:		Fri Dec 12 09:29:04 2008



 ***************************************************************************
 ***************************************************************************/
static void remap ( void ) {
  int mode=O_RDONLY , prot = PROT_READ;
  char str[200]="cannot write ";
  
	if(!dumpPath){
        	EDITABLE = FALSE;
                XmToggleButtonSetState(Hex_edit,FALSE,FALSE);
                return;
        }
        munmap(Map, Map_Size);        
        close(DumpFd );
        if(EDITABLE){
        	mode = O_RDWR;
                prot |= PROT_WRITE;
                mode = O_RDWR;
        }        	
        

        DumpFd = open(dumpPath, mode);
        if(DumpFd < 0){
        	strcat(str,dumpPath);
                Error_Create (Hex_edit, str);
                EDITABLE = FALSE;
		XtVaSetValues(Hex_input,XmNeditable,FALSE
                ,XmNbackground,MGetPixel("linen", Hex_input),NULL);
 		XtVaSetValues(Hex_edit,XmNbackground,MGetPixel("linen", Hex_edit),NULL);
                XmToggleButtonSetState(Hex_edit,FALSE,FALSE);
                prot = PROT_READ;
                DumpFd = open(dumpPath, O_RDONLY);
        }         
/* dialog is using XtParent(parent)   check if correct */
        Map = (unsigned char *)mmap(NULL,Map_Size,prot,MAP_SHARED,DumpFd,0);        	
}
static void open_logfile ( char *path ) {
  char str[200]="cannot write  ";

	Log = fopen(path,"w");
        if(!Log){
        	strcat(str,path);
        	Error_Create (Hex_control, str);
                Log = 0;
        }
}
static void get_printfile ( char *path  ) {

	if(printpath)
        	free(printpath);
        printpath = strdup(path);        
}
