/*
   Widgetklasse:	XmGrFormClass
   GrFormP.h

$Revision: 1.1 $

$Log: GrFormP.h,v $
Revision 1.1  2008/12/23 14:22:33  keidel
added used parts of easymotif lib as source

Revision 1.2  2004/06/05 07:46:59  keidel
bug fixes

Revision 4.0  2004/02/28 09:53:00  keidel
Major Version

Revision 1.2  2004/02/28 09:20:23  keidel
complete graphic-extension, creating C-code, save/restore, display and editing
Line, Polygon, Circle, Rectangle
moving points, setting effects, color, style, fill, linewidth etc.

inhibit buttonpress while pointer grabbed.
corrected GrForm for change managed
attachments to Form with Frame/Scroll corrected
better reaction on -UGRFORM
use Grid of GrForm if GrForm enabled  (GrGrid added to GrForm)

Revision 1.1  2004/02/23 14:56:04  keidel
added GrForm widget as extewrnsion to XmForm. This adds
a graphic extension to the standard form, including dynamic effects
and grid.

Revision 1.1  2003/12/29 10:15:23  keidel
add histspectr widget
add GRForm widget, replace XmForm conditionally

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2, or (at your option)
        any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "GrForm.h"
#include <Xm/FormP.h>
#ifndef _XmGrFormP_h
#define _XmGrFormP_h


#ifdef __cplusplus
extern "C" {
#endif
#define GMode(g)	    ((g)->request_mode)
#define IsQueryOnly(g)      (GMode (g) & XtCWQueryOnly)
#define IsX(g)		    (GMode (g) & CWX)
#define IsY(g)		    (GMode (g) & CWY)
#define IsWidth(g)	    (GMode (g) & CWWidth)
#define IsHeight(g)	    (GMode (g) & CWHeight)
#define IsBorder(g)	    (GMode (g) & CWBorderWidth)

externalref WidgetClass xmGrFormWidgetClass;


#ifndef XmIsGrForm
#define XmIsGrForm(w)  (XtIsSubclass (w, xmGrFormWidgetClass))
#endif

#define AttachesIncrement 100
#define ArrowSize   15
/*  New fields for the GrForm widget class record  */

typedef struct
{
        XtPointer                 extension;   
} XmGrFormClassPart;


/* Full class record declaration */

typedef struct _XmGrFormClassRec
{
	CoreClassPart		  core_class;
	CompositeClassPart	  composite_class;
	ConstraintClassPart	  constraint_class;
	XmManagerClassPart	  manager_class;
        XmBulletinBoardClassPart  bulletin_board_class;
        XmFormClassPart           form_class; 
	XmGrFormClassPart	  GrForm_class;
}XmGrFormClassRec;

externalref XmGrFormClassRec xmGrFormClassRec;


/* New fields for the GrForm widget record */

typedef struct
{
 /* need a foreground resource */   
    
    GrObject        *obj;
    unsigned char   flags;
    GC		    gc;		        /* graphic context */
    Boolean         grevent;            /* event handler internal activated */
    XmFontList 	    font_list;		/* fontlist for annotation */
    XFontStruct     *font_struct;
    Widget          *attached;
    int              n_attaches;
    int             Id_counter;
    int             recalc;
    GrObject        *actobj;
    GrPrimitive     *actprim;
    GrVertex        *actvert;
    int             offset;
    XtIntervalId    flowtimer;
    int             cntflag;
} XmGrFormPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _XmGrFormRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
        XmBulletinBoardPart     bulletin_board;
        XmFormPart              form;
	XmGrFormPart	        GrForm;
} XmGrFormRec , *XmGrFormWidget;


/********    Private Function Declarations    ********/
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmGrFormP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
